      *===============================================================*
      *
      * ONL-LINK.CPY
      *
      * Interface for On-Line Documentation System display program.
      * Used as per this code sample:
      *
      *call-on-line section.
      *    call "on-line"
      *        using on-line-pb
      *              on-line-topic
      *    if on-line-return not = 0
      *        display "on-line error:- " on-line-return
      *    end-if
      *    .
      *
      *---------------------------------------------------------------*

       01 on-line-pb.
       78 on-line-pb-start             value next.
               78 on-line-initialize           value 0.
               78 on-line-qry-by-name          value 1.
               78 on-line-qry-by-context       value 2.
               78 on-line-close-down           value 4.
               78 on-line-index                value 5.
               78 on-line-contents             value 6.
               78 on-line-add-file             value 7.
           03 on-line-action           pic 9(2) comp-x
                                       value on-line-qry-by-context.
               78 on-line-bad-action           value 1.
               78 on-line-topic-not-found      value 2.
               78 on-line-file-not-found       value 3.
               78 on-line-init-failure         value 4.
               78 on-line-terminate-failure    value 5.
               78 on-line-no-help-files        value 6.
               78 on-line-onleng-failure       value 7.
               78 on-line-memory-failure       value 8.
               78 hyhelp-nameprogram-fail      value 100.
               78 hyhelp-adiskey-fail          value 101.
               78 hyhelp-panels-fail           value 102.
           03 on-line-return           pic 9(2) comp-x value 0.
           03 on-line-flags            pic 9(2) comp-x value 0.
               78 on-line-default-window       value 0.
               78 on-line-window-specified     value 7.
           03 on-line-win-flags        pic 9(2) comp-x
                                       value on-line-default-window.
           03 on-line-context-no       pic 9(4) comp-5 value 1.
           03 on-line-ptr              pic 9(4) comp-5 value 0.
           03 on-line-window-desc.
               05 on-line-window-x     pic 9(4) comp-5 value 0.
               05 on-line-window-y     pic 9(4) comp-5 value 0.
               05 on-line-win-width    pic 9(4) comp-5 value 0.
               05 on-line-win-height   pic 9(4) comp-5 value 0.
           03  on-line-ui-id           pic 9(9) comp-5 value 0.

       78 on-line-pb-len               value next - on-line-pb-start.

      *---------------------------------------------------------------*
      *
      * on-line-flags:
      *
      * -  bit 7 - when set, in HYHELP, menus will not appear
      * -  bit 6 - reserved (multi-thread)
      * -  bit 5 - when set, the screen is left displayed on exit
      * -  bit 4 - when set, default topic assumed when none specified
      * -  bit 3 - when set, no files are opened on initialization
      * -  bit 2 - when set, user screen is saved, and restored on exit.
      * -  bit 1 - when set, close all files on exit
      * -  bit 0 - when set, deallocated memory buffers on exit
      *
      *
      * on-line-win-flags:
      *
      * -  bit 2 - set if the parameters given for size are to be used
      * -  bit 1 - set if the parameters given for locn are to be used
      * -  bit 0 - set if Panels is already initialized (ON-LINE only)
      *
      * NB. The default ON-LINE window in PM is 15 character lines
      *     high, and the width is such that the buttons fit exactly
      *
      *     The default ON-LINE window in character mode is full screen
      *
      * on-line-topic:
      *
      *    alphanumeric item - space terminated.
      *
      *===============================================================*
