      *
      * @(#)mudemo.cbl	1.5

      ****************************************************************
      * Copyright Micro Focus Limited 1989-92. All Rights Reserved.  *
      * This demonstration program is provided for use by users of   *
      * Micro Focus products and may be used, modified and           *
      * distributed as part of your application provided that you    *
      * properly acknowledge the copyright of Micro Focus in this    *
      * material.                                                    *
      ****************************************************************

       IDENTIFICATION DIVISION.
       PROGRAM-ID.  MULTI-USER-DEMO.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.
	  CONSOLE IS CRT.

       DATA DIVISION.

       WORKING-STORAGE SECTION.
       01  MUDEMO01-00	 .
	   03 FILLER	       PIC X(0030).
	   03 MUDEMO01-00-0131 PIC X(0016) VALUE "================".
	   03 FILLER	       PIC X(0064).
	   03 MUDEMO01-00-0231 PIC X(0016) VALUE "MICRO FOCUS LTD.".
	   03 FILLER	       PIC X(0064).
	   03 MUDEMO01-00-0331 PIC X(0016) VALUE "================".
	   03 FILLER	       PIC X(0201).
	   03 MUDEMO01-00-0608 PIC X(0060) VALUE "This is a demonstratio
      -    "n program for use with COBOL.   ".
	   03 FILLER	       PIC X(0100).
	   03 MUDEMO01-00-0808 PIC X(0058) VALUE "The program demonstrat
      -    "es how multi-user COBOL can   ".
	   03 FILLER	       PIC X(0102).
	   03 MUDEMO01-00-1008 PIC X(0028) VALUE "lock both records and
      -    "files.".
	   03 FILLER	       PIC X(0212).
	   03 MUDEMO01-00-1308 PIC X(0062) VALUE "The program allows an
      -    "indexed file to be opened in a number of".
	   03 FILLER	       PIC X(0098).
	   03 MUDEMO01-00-1508 PIC X(0046) VALUE "modes, which demonstra
      -    "te the locking facility.".
	   03 FILLER	       PIC X(0114).
	   03 MUDEMO01-00-1708 PIC X(0063) VALUE "For more information o
      -    "n locking refer to the Language Reference".
	   03 FILLER	       PIC X(0097).
	   03 MUDEMO01-00-1908 PIC X(0007) VALUE "Manual.".
	   03 FILLER	       PIC X(0146).
	   03 MUDEMO01-00-2101 PIC X(0080) VALUE "----------------------
      -    "----------------------------------------------------------".

       01  OPTIONS.
	   03  FILLER			PIC X(02).
	   03  OPTION-1 		PIC X(07)
		   VALUE "1.Input".
	   03  FILLER			PIC X(02).
	   03  OPTION-2 		PIC X(25)
		   VALUE "2.I-O Lock Mode Automatic".
	   03  FILLER			PIC X(02).
	   03  OPTION-3 		PIC X(22)
		   VALUE "3.I-O Lock Mode Manual".
	   03  FILLER			PIC X(02).
	   03  OPTION-4 		PIC X(08)
		   VALUE "4.Output".
	   03  FILLER			PIC X(02).
	   03  OPTION-5 		PIC X(06)
		   VALUE "5.Exit".


       01  DATE-TO-DAY.
	   03  DAYS			PIC 99.
	   03  FILLER			PIC X.
	   03  MONTH			PIC 99.
	   03  FILLER			PIC X.
	   03  YEAR			PIC 99.

       01  UP-TO-DATE-TIME.
	   03  HOURS			PIC 99.
	   03  FILLER			PIC X.
	   03  MINS			PIC 99.

       01  TEMP-DATE.
	   03  TEMP-YEAR		PIC XX.
	   03  TEMP-MONTH		PIC XX.
	   03  TEMP-DAY 		PIC XX.
       01  TEMP-TIME.
	   03  TEMP-HOURS		PIC 99.
	   03  TEMP-MINS		PIC 99.
	   03  TEMP-REST		PIC 9999.

       01  CHOICE			PIC 9 VALUE 0.

       01  AD-FLAG			PIC 9(2) COMP VALUE 3.
       01  AD-PARAM-BLOCK.
           03 VALUE-TO-SET		PIC 9(2) COMP VALUE 1.
           03 BYTE-TO-SET		PIC 9(2) COMP VALUE 62.

      **********************************************************
      * MAIN PROGRAM					       *
      **********************************************************

       PROCEDURE DIVISION.
       ENT-RY.
	   DISPLAY SPACE.
      * Set CRT-UNDER mode to high-intensity.
	   CALL X"AF" USING AD-FLAG, AD-PARAM-BLOCK.
	   DISPLAY MUDEMO01-00.
	   PERFORM DISPLAY-DATE.
	   PERFORM DISPLAY-TIME.
	   DISPLAY OPTIONS AT 2201.
	   DISPLAY "INPUT CHOICE [ ]" AT 2431 UPON CRT-UNDER.


       RE-ENTER-CHOICE.
	   ACCEPT CHOICE AT 2445.
	   IF CHOICE = 1 CALL "stockin"
			 CANCEL "stockin"
			 GO TO ENT-RY.
	   IF CHOICE = 2 CALL "stockioa"
			 CANCEL "stockioa"
			 GO TO ENT-RY.
	   IF CHOICE = 3 CALL "stockiom"
			 CANCEL "stockiom"
			 GO TO ENT-RY.
	   IF CHOICE = 4 CALL "stockout"
			 CANCEL "stockout"
			 GO TO ENT-RY.
	   IF CHOICE = 5 GO TO ENDIT.

	   GO TO RE-ENTER-CHOICE.

       ENDIT.
	   STOP RUN.


      ***********************************************************
      * DATE AND TIME ROUTINES					*
      ***********************************************************

       DISPLAY-DATE.
	  ACCEPT TEMP-DATE FROM DATE.
	  MOVE TEMP-DAY TO DAYS.
	  MOVE TEMP-MONTH TO MONTH.
	  MOVE TEMP-YEAR TO YEAR.
	  DISPLAY "Date   /  /" AT 0164.
	  DISPLAY DATE-TO-DAY AT 0169.

       DISPLAY-TIME.
	  ACCEPT TEMP-TIME FROM TIME.
	  MOVE TEMP-HOURS TO HOURS.
	  MOVE TEMP-MINS TO MINS.
	  DISPLAY "Time   :" AT 0264.
	  DISPLAY UP-TO-DATE-TIME AT 0269.
