/****************************************************************************
 *
 *	Copyright (C) 1984-1997 Micro Focus Ltd.
 *
 *	All rights reserved.  Unpublished, all rights reserved under
 *	copyright law and international treaty.  Use of a copyright notice
 *	is precautionary only and does not imply publication or disclosure.
 *	This software contains confidential information and trade secrets of
 *	Micro Focus Ltd. and no part of this program or publication may be
 *	reproduced, transmitted, transcribed, stored in a retrieval system,
 *	or translated into any language or computer language, in any form
 *	or by any means, electronic, mechanical, magnetic, optical, chemical,
 *	manual or otherwise, without the prior written permission of:
 *
 *	Micro Focus Ltd,
 *	Speen Court, 7 Oxford Road, Newbury, Berkshire, RG14 1PB, UK.
 *	(01635) 32646
 *
 *	RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to
 *	restrictions as set forth in subparagraph (c)(1)(ii) of the Rights
 *	in Technical Data and Computer Software clause at DFARS 52.227-7013
 *	or subparagraphs (c)(1) and (2) of Commercial Computer Software -
 *	Restricted Rights at 48 CFR 52.227-19, as applicable.  Contact
 *	Micro Focus Incorporated, 2465 East Bayshore Road, Palo Alto,
 *	California 94303.
 *
 *	Phase 9a Base Run Time System
 *
 *	@(#)shcob.h	1.4
 *
 *	Last Modified on 96/09/06 at 14:24:56
 *
 ****************************************************************************/

/** Start of source module shcob.h **/

#define	ERR	(-1)
#define	OK	(0)

/* you may include this file for using the screen handling calls in
 * the Micro Focus COBOL system */

/* ATTRIBUTES */
/* These attributes are based upon the default attribute byte value (see
 * your documentation for details) but have been shifted left */

#define	A_NORMAL	0 << 8	/* normal, no attributes */
#define	A_BOLD		1 << 8	/* bold */
#define	A_UNDER		2 << 8	/* underline */
#define	A_REVERSE	4 << 8	/* reverse video */
#define	A_BLINK		8 << 8	/* blinking */
#define	A_DIM		64 << 8	/* dim */

/* combined characters and attributes should be of type 'cobchtype' */
typedef	unsigned short cobchtype;

/* external definitions */
void cobaddch();
void cobmove();
int cobaddstr();
int cobaddstrc();
#ifdef __STDC__
int cobprintf(char *, ...);
#else
int cobprintf();
#endif
void cobscroll();
void cobclear();
int cobgetch();
int coblines();
int cobcols();

/** End of source module shcob.h **/
