/************************************************************************
 *
 *	Copyright (C) 1984-1997 Micro Focus Ltd.
 *
 *	All  rights reserved.  No part of this program or  publication
 *	may  be  reproduced,  transmitted,  transcribed,  stored  in a
 *	retrieval system,  or translated into any language or computer
 *	language, in any form or by any means, electronic, mechanical,
 *	magnetic,  optical, chemical, manual or otherwise, without the
 *	prior written permission of:
 *
 *	Micro Focus Ltd,
 *	26 West Street, Newbury, Berkshire, United Kingdom.             
 *	(0635) 32646
 *
 *	Phase 9a Base Run Time System
 *
 *	Source Module fhstat.c	Sccs Identification 1.4
 *
 *	Last Modified on 95/02/14 at 15:34:50
 *
 ************************************************************************/

static char sccsid[] = "@(#)fhstat.c	1.4";


/* IMPORTANT:
 * For all tables, ensure that no entries are deleted or added but are only
 * changed. 
 * It is not recommended that the ANSI-74 or ANSI-85 tables are changed, but
 * the alternate table may be altered to give different statuses */

/*
 * Table of ANSI-85 file statuses
 */
unsigned char mFt_ans85stat[][2] =
{
    { '0',	'0' },		/* no error - successful completion	*/
    { '0',	'2' },		/* isam record read has duplicates	*/
    { '0',	'4' },		/* read different length record		*/
    { '0',	'5' },		/* optional file did not exist		*/
    { '0',	'7' },		/* not a reel / unit medium		*/

    { '1',	'0' },		/* end of file				*/
    { '1',	'4' },		/* relative key too big			*/

    { '2',	'1' },		/* sequence error (SEQ access of ISAM)	*/
    { '2',	'2' },		/* attempt to create duplicate key	*/
    { '2',	'3' },		/* record does not exist		*/
    { '2',	'4' },		/* attempt to write outside file limits	*/

    { '3',	'0' },		/* permanent i/o error			*/
    { '9',	 18 },		/* part record read			*/
    { '3',	'4' },		/* attempt to write beyond file boundary*/
    { '3',	'5' },		/* not-optional file does not exist	*/
    { '3',	'7' },		/* cannot access file in specified mode	*/
    { '3',	'8' },		/* file was closed with lock		*/
    { '3',	'9' },		/* file attribute conflict		*/

    { '4',	'1' },		/* attempt to open file already open	*/
    { '4',	'2' },		/* attempt to close file already closed	*/
    { '4',	'3' },		/* rewrite / delete sequencing error	*/
    { '4',	'4' },		/* boundary violation			*/
    { '4',	'6' },		/* no next record for read-next		*/
    { '4',	'7' },		/* bad open mode for read / start	*/
    { '4',	'8' },		/* bad open mode for write		*/
    { '4',	'9' },		/* bad open mode for rewrite / delete	*/

    { '9',	'A' },		/* file locked				*/
    { '9',	'D' },		/* record locked			*/
    { '9',	 0  },		/* implementor defined error		*/
    { '9',	'+' },		/* index information missing 		*/
    { '9',	126 },		/* Record size exceeds system limit	*/
    { '9',	9   },		/* Directory does not exist		*/
};


/*
 * Table of ANSI-74 file statuses
 */
unsigned char mFt_ans74stat[][2] =
{
    { '0',	'0' },		/* no error - successful completion	*/
    { '0',	'2' },		/* isam record read has duplicates	*/
    { '0',	'0' },		/* read different length record		*/
    { '0',	'0' },		/* optional file did not exist		*/
    { '0',	'0' },		/* not a reel / unit medium		*/

    { '1',	'0' },		/* end of file				*/
    { '9',	196 },		/* relative key too big			*/

    { '2',	'1' },		/* sequence error (SEQ access of ISAM)	*/
    { '2',	'2' },		/* attempt to create duplicate key	*/
    { '2',	'3' },		/* record does not exist		*/
    { '2',	'4' },		/* attempt to write outside file limits	*/

    { '9',	 33 },		/* permanent i/o error			*/
    { '9',       18 },		/* part record read			*/
    { '9',	194 },		/* attempt to write beyond file boundary*/
    { '9',	 13 },		/* not-optional file does not exist	*/
    { '9',	 35 },		/* cannot access file in specified mode	*/
    { '9',	210 },		/* file was closed with lock		*/
    { '9',	139 },		/* file attribute conflict		*/

    { '9',	141 },		/* attempt to open file already open	*/
    { '9',	142 },		/* attempt to close file already closed	*/
    { '9',	143 },		/* rewrite / delete sequencing error	*/
    { '9',	139 },		/* boundary violation			*/
    { '9',	146 },		/* no next record for read-next		*/
    { '9',	147 },		/* bad open mode for read / start	*/
    { '9',	148 },		/* bad open mode for write		*/
    { '9',	149 },		/* bad open mode for rewrite / delete	*/

    { '9',	'A' },		/* file locked				*/
    { '9',	'D' },		/* record locked			*/
    { '9',	  0 },		/* implementor defined error		*/
    { '9',	'+' },		/* index information missing 		*/
    { '9',	126 },		/* Record size exceeds system limit	*/
    { '9',	9   },		/* Directory does not exist		*/
};

/*
 * Alternate table for re-mapping file status '9' error.
 * By default, these contain codes for RM compatibility.
 * To re-map the status, index the table by the second byte
 * of the status '9' item - the table entry contains the new
 * file status in BCD - convert to 2 byte ASCII before storing.
 * The default entry in the table is '30' - permanent i/o error.
 */

unsigned char mFt_alt_stat[256] =
{
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/*   0 -  9 */
    0x30, 0x30, 0x30, 0x94, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/*  10 - 19 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/*  20 - 29 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x94, 0x30, 0x94, 0x30, 0x30,	/*  30 - 39 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/*  40 - 49 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/*  50 - 59 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x99, 0x30, 0x30, 0x99, 0x30,	/*  60 - 69 */
    0x30, 0x98, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/*  70 - 79 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/*  80 - 89 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/*  90 - 99 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 100 - 109 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 110 - 119 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 120 - 129 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x93, 0x94,	/* 130 - 139 */
    0x30, 0x92, 0x91, 0x90, 0x30, 0x30, 0x96, 0x90, 0x90, 0x90,	/* 140 - 149 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 150 - 159 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 160 - 169 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 170 - 179 */
    0x30, 0x30, 0x94, 0x94, 0x30, 0x30, 0x30, 0x30, 0x94, 0x30,	/* 180 - 189 */
    0x30, 0x30, 0x30, 0x30, 0x34, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 190 - 199 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 200 - 209 */
    0x93, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 210 - 219 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 220 - 229 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 230 - 239 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30,	/* 240 - 249 */
    0x30, 0x30, 0x30, 0x30, 0x30, 0x30				/* 250 - 255 */
};

/* end of source module fhstat.c */
