/************************************************************************
 *
 *	Copyright (C) 1984-1997 Micro Focus Ltd.
 *
 *	All  rights reserved.  No part of this program or  publication
 *	may  be  reproduced,  transmitted,  transcribed,  stored  in a
 *	retrieval system,  or translated into any language or computer
 *	language, in any form or by any means, electronic, mechanical,
 *	magnetic,  optical, chemical, manual or otherwise, without the
 *	prior written permission of:
 *
 *	Micro Focus Ltd,
 *	26 West Street, Newbury, Berkshire, United Kingdom.             
 *	(0635) 32646
 *
 *	Phase 9a Base Run Time System
 *
 *	@(#)mf_types.h	1.4
 *
 *	Last Modified on 98/02/12 at 00:42:38
 *
 ************************************************************************/

#ifndef	MF_TYPES
#define	MF_TYPES

typedef	int				mf_boolean;
#ifndef	TRUE
#define	FALSE	(0)
#define	TRUE	(!FALSE)
#endif

typedef unsigned char mf_uns8;
typedef unsigned short mf_uns16;
typedef short mf_s16;
typedef unsigned int mf_cblptr;  /* 32-bit COBOL pointer */
#ifdef ALPHA_OSF1
typedef unsigned int mf_uns32;
typedef int mf_s32;
#else /* ALPHA_OSF1 */
typedef unsigned long mf_uns32;
typedef long mf_s32;
#endif /* ALPHA_OSF1 */
typedef double mf_flt;		 /* Floating point data type. Max precision */
typedef void *mf_sigtype;
typedef void *mf_eptype;

typedef int	(*PFI)();	/* pointer to function returning int	*/
typedef void	(*PFV)();	/* pointer to function returning void	*/
typedef unsigned long (*PFUL)(); /*pointer to function returning unsigned long*/

typedef struct	lddtab LDT;
typedef char	*charptr;	/* pointer to character */
typedef char	**charpp;	/* pointer to string */
#ifdef	NOPID_T
typedef	mf_s32	pid_t;
#endif /* NOPID_T */
#ifdef NOCADDR_T
typedef	char 	*caddr_t;
#endif /* NOCADDR_T */

#ifdef NOSIZE_T
typedef mf_uns32 size_t;
#endif /* NOSIZE_T */

#endif	/* MF_TYPES */

/*** end of source module mf_types.h ***/
