      *>----------------------------------------------------------------
      *> An Array is a indexed collection of objects or intrinsic
      *> data. The indices should be pic x(4) comp-5 items and range in
      *> value between 1 and the size of the array.
      *>
      *> Copyright (C) 1991,1996 Micro Focus Ltd
      *>
      *>----------------------------------------------------------------
      $set mfoo
       class-id. array data is protected
               inherits from arrayedcollection with data.


        object section.
        class-control.
           arrayedcollection is class "arrayed"
           array is class "array".
       object-storage section.

       Object.

       object-storage section.
      *>----------------------------------------------------------------
      *> Returns self as this is already an instance of Array.
      *>----------------------------------------------------------------
       method-id. "asArray".
       linkage section.
       01 defaultresult    usage object reference.

       procedure division returning defaultresult.
           invoke self "basicCopy" returning defaultResult
           exit method.
       end method "asArray".
      *>----------------------------------------------------------------
      *> Return the element at index position anIndex. Raise an
      *> exception if anIndex is outside the bounds of the array.
      *>----------------------------------------------------------------
       method-id. "at".
       local-storage section.
       01 realindex             pic s9(9) comp-5.

       linkage section.
       01 anindex              pic s9(9) comp-5.
       01 returnelement.
           03 abyte            pic x occurs 0 to maxnumberbytes
                                     depending on collectionstride.

       procedure division using anindex returning returnelement.
           if anindex < 1 or anindex > numberelements
               invoke self "errorInBounds" returning returnelement
               exit method
           else
               compute realindex = (anindex - 1) * collectionstride + 1
                                   + indexeddataoffset
               move instancedata(realindex : collectionstride)
                 to returnelement
               exit method
           end-if.
       end method "at".
      *>---------------------------------------------------------------
      *> Store aValue at position anIndex. Raise an
      *> exception if anIndex is outside the bounds of the array.
      *>---------------------------------------------------------------
       method-id. "atPut".
       local-storage section.
       01 realindex             pic s9(9) comp-5.

       linkage section.
       01 anindex              pic s9(9) comp-5.
       01 avalue.
           03 abyte            pic x occurs 0 to maxNumberBytes
                                     depending on collectionstride.
       procedure division using anindex avalue.
           if anindex < 1 or anindex > numberelements
               invoke self "errorinBounds"
           else
               compute realindex = (anindex - 1) * collectionstride + 1
                                    + indexeddataoffset
               move avalue to instancedata(realindex : collectionstride)
           end-if
           exit method.
       end method "atPut".
       end object.
       end class array.
