      *>---------------------------------------------------------------
      *> Base is the superclass of all other classes. It handles the
      *> default behavior for methods which deal with hashing, error
      *> handling and persistence.
      *>
      *> Copyright (c) Micro Focus Ltd 1991, 1996
      *>
      *>----------------------------------------------------------------
      $set mfoo  localcount(256) early-release linkcount(320)
           copy "chararry.if".
           copy "base.if".
       class-id. base is abstract data is protected.


        object section.
        class-control.
           Base is class "base"
           Callback is class "callback"
           CharacterArray is class "chararry"
           cobolcomp5 is class "comp5"
           ExceptionManager is class "exptnmgr"
           persistencemanager is class "persist"
           DelegateManager is class "delegate"
           IdentitySet is class "iset"
           Event is class "event"
           Dictionary is class "dictinry"
           IdentityDictionary is class "idictnry"
           SystemDictionary is class "systemd"
           OrderedCollection is class "ordrdcll"
           CobolComp5Association is class "compasoc"
           PicXToObject is class "picxtoob"
           Association is class "associtn"
           MessageFileHandler is class "msgfh"
           .
       working-storage section.

       78  numberOfStandardOutputs      value 20.
       78  numberOfStandardSockets      value 5.
       78  numberOfStandardDependants   value 5.
       78  numberOfStandardSpies        value 1.
       78  numberOfSocketSignals        value 20.
       78  numberOfHandlersForSignal    value 5.

       78  inputSocketUndefined         value 93.
       78  outputSocketUninitialized    value 94.
       78  outputSignalUndefined        value 95.
       78  duplicateOutputSignal        value 96.
       78  internalError                value 97.
       78  duplicateInputSignal         value 98.
       78  resourceNotFound             value 99.
       78  resourceFileError            value 100.
       78  traceRecordTooLong           value 101.

       78  numberOfEventObjects         value 1024.
       78  numberOfRegisteredEvents     value 20.

       object-storage section.
      *>>---------------------------------------------------------------
      *>> The maximum size in bytes of an OBJECT.  Limit is 256Meg.
      *>>---------------------------------------------------------------
       78 maxnumberbytes               value h"0FFFFFFF".

      *>>---------------------------------------------------------------
      *>> The size of an object reference
      *>>---------------------------------------------------------------
       78 objectReferenceSize          value 4.

      *>----------------------------------------------------------------
      *> PRIVATE. Load pre-saved data from file. This should not be
      *> included as a class method.
      *>----------------------------------------------------------------

       method-id. "resume".
       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.

       linkage section.
       01 objectdetails.
           03 objhandle    pic x(4) comp-5.
           03 objsize      pic x(4) comp-5.
           03 objaddress   pointer.

       procedure division using objectdetails.
           if self equal to null
               move 27 to exceptionnumber
               invoke self "raiseException" using exceptionnumber
           else
               if objsize not = zero
                  invoke persistencemanager "read" using objectdetails
               end-if
           end-if
           invoke self "reset"
           exit method.
       end method "resume".

      *>----------------------------------------------------------------
      *> This method is included in the class as well as the instance
      *> methods otherwise it will not get resolved for the class base
      *> on a second run.
      *>----------------------------------------------------------------

       method-id. "reset".
       procedure division.
           exit method.
       end method "reset".

      *>----------------------------------------------------------------
      *> PRIVATE. Change references of this object to point to lnkObject
      *> and vice versa. However this is not allowed currently for
      *> classes.
      *>----------------------------------------------------------------

       method-id. "becomes".
       local-storage section.
       01 i           pic x(4) comp-5.
       01 anObject    usage object reference.
       procedure division.
           move 88 to i
           invoke self "raiseException" using i returning anObject
       end method "becomes".

       Object.

       object-storage section.
      *>>---------------------------------------------------------------
      *>> The maximum size in bytes of an OBJECT.  Limit is 256Meg.
      *>>---------------------------------------------------------------
       78 maxnumberbytes               value h"0FFFFFFF".

      *>>---------------------------------------------------------------
      *>> The size of an object reference
      *>>---------------------------------------------------------------
       78 objectReferenceSize          value 4.
      *>----------------------------------------------------------------
      *> Answer true if the receiver is a kind of menu, else answer
      *> false.
      *>----------------------------------------------------------------

       method-id. "isMenu".
       linkage section.
       01 lnkbool                pic x comp-5.

       procedure division returning lnkbool.
           move 0 to lnkbool
           exit method.
       end method "isMenu".
      *>----------------------------------------------------------------
      *> Answer true if the receiver is a color, else answer false.
      *>----------------------------------------------------------------

       method-id. "isColor".
       linkage section.
       01 lnkbool               pic x comp-5.

       procedure division returning lnkbool.
           move 0 to lnkbool
           exit method.
       end method "isColor".
      *>----------------------------------------------------------------
      *> Answer true if the receiver is a bitmap, else answer false.
      *>----------------------------------------------------------------

       method-id. "isBitmap".
       linkage section.
       01 lnkbool               pic x comp-5.

       procedure division returning lnkbool.
           move 0 to lnkbool
           exit method.
       end method "isBitmap".
      *>----------------------------------------------------------------
      *> Answer true if the receiver is an icon, else answer false.
      *>----------------------------------------------------------------

       method-id. "isIcon".
       linkage section.
       01 lnkbool               pic x comp-5.

       procedure division returning lnkbool.
           move 0 to lnkbool
           exit method.
       end method "isIcon".
      *>----------------------------------------------------------------
      *> Answer true if the receiver is a DBCSCharacterArray otherwise
      *> answer false.
      *>----------------------------------------------------------------

       method-id. "isDBCSCharacterArray".
       linkage section.
       01 lnkbool                pic x comp-5.

       procedure division returning lnkbool.
           move 0 to lnkbool
           exit method.
       end method "isDBCSCharacterArray".
      *>----------------------------------------------------------------
      *> Answer true if we are in a DBCS environment otherwise return
      *> false.
      *>----------------------------------------------------------------

       method-id. "isDBCSEnvironment".
       local-storage section.
       01 OS-Info-Param-Block.
           03  Parameter-Size         PIC X(2) COMP-X.
           03  P-OS-Type              PIC X    COMP-X.
           03  p-os-version           PIC X(4) comp-x.
           03  p-dbcs-support         pic x    comp-x.
           03  filler                 pic x(10).
       linkage section.
       01 lnkbool                     pic x comp-5.

       procedure division returning lnkbool.
           move length of OS-Info-Param-Block to parameter-size
           CALL "CBL_GET_OS_INFO" USING OS-Info-Param-Block
           move h"01" to lnkBool
           call "CBL_AND" using p-dbcs-support
                                lnkBool
                                by value 1 size 4
           exit method.
       end method "isDBCSEnvironment".
      *>----------------------------------------------------------------
      *> Return true is this object is a class otherwise return false.
      *>----------------------------------------------------------------
       method-id. "isClass".
       linkage section.
       01 lnkbool                pic x comp-5.
       procedure division returning lnkbool.
           move 0 to lnkBool
           exit method.
       end method "isClass".

      *>----------------------------------------------------------------
      *> Answer true if the receiver is a kind of printer, else answer
      *> false.
      *>----------------------------------------------------------------

       method-id. "isPrinter".
       linkage section.
       01 lnkbool                pic x comp-5.

       procedure division returning lnkbool.
           move 0 to lnkbool
           exit method.
       end method "isPrinter".
      *>------------------------------------------------------------
      *> Respond true if input signal lnkSignalId has been defined
      *> on socket lnkSocketId.
      *>------------------------------------------------------------
       Method-id. "isInputSignal".
       local-storage section.
       01  lsPointer                  pointer.
       01  lsSocket                   object reference.
       01  lsCallback                 object reference.
       01  lsSignalId                 pic x(32).
       01  lsSocketId                 pic x(32).
       01  i                          pic s9(9) comp-5.

       linkage section.
       01  lnkSocketId                pic x(32).
       01  lnkSignalId                pic x(32).
       copy "compnent.cpy".
       01  lnkBool                    pic x comp-5.
           88 isTrue                  value 1.
           88 isFalse                 value 0.

       procedure division using lnkSocketId
                                lnkSignalId
                      returning lnkBool.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           move spaces to lsSocketId
           perform varying i from 1 by 1
                   until lnkSocketId(i:1) = x"00"
                   or    lnkSocketId(i:1) = space
               move lnkSocketId(i:1) to lsSocketId(i:1)
           end-perform
           move spaces to lsSignalId
           perform varying i from 1 by 1
                   until lnkSignalId(i:1) = x"00"
                   or    lnkSignalId(i:1) = space
               move lnkSignalId(i:1) to lsSignalId(i:1)
           end-perform
           invoke self "getSocket" using lsSocketId(1:32)
                               returning lsSocket
           if lsSocket <> null
               invoke lsSocket "atOrNil" using lsSignalId
                                     returning lsCallback
               if lsCallback <> null
                   set isTrue to true
               else
                   set isFalse to true
               end-if
           else
               set isFalse to true
           end-if
           exit method.
       end method "isInputSignal".
      *>------------------------------------------------------------
      *> Returns an IdentitySet containing handlers of an output
      *> signal. Returns nil if none.
      *>------------------------------------------------------------
       Method-id. "getSignalHandlers".
       local-storage section.
       01  lsSignalHandlers           object reference.
       01  i                          pic s9(9) comp-5.
       01  lsCallback                 object reference.

       linkage section.
       01  lnkSignalId                pic x(32).
       01  lnkSignalHandlers          object reference.

       procedure division using lnkSignalId
                      returning lnkSignalHandlers.
           invoke self "getOutputSignalCallbacks" using lnkSignalId
                                      returning lsSignalHandlers
           if lsSignalHandlers <> null
               invoke lsSignalHandlers "size" returning i
               invoke IdentitySet "ofReferences" using i
                                       returning lnkSignalHandlers
               invoke Callback "new" using self "addReceiver "
                                           lnkSignalHandlers
                                 returning lsCallback
               invoke lsSignalHandlers "do" using lsCallback
           else
               set lnkSignalHandlers to null
           end-if
           exit method.
       end method "getSignalHandlers".
      *>------------------------------------------------------------
      *> PRIVATE. Returns the callbacks handling an output signal
      *> for a component
      *>------------------------------------------------------------
       Method-id. "getOutputSignalCallbacks".
       local-storage section.
       01  lsSignalId                 pic x(32).
       01  i                          pic s9(9) comp-5.
       01  lsPointer                  pointer.

       linkage section.
       01  lnkSignalId                pic x(32).
       01  lnkSignalHandlers          object reference.
       copy "compnent.cpy".

       procedure division using lnkSignalId
                      returning lnkSignalHandlers.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           move spaces to lsSignalId
           perform varying i from 1 by 1
                   until lnkSignalId(i:1) = x"00"
                   or    lnkSignalId(i:1) = space
               move lnkSignalId(i:1) to lsSignalId(i:1)
           end-perform
           if outputs <> null
               invoke outputs "atOrNil" using lsSignalId(1:32)
                                    returning lnkSignalHandlers
           else
               raise exception outputSocketUninitialized
           end-if
           exit method.
       end method "getOutputSignalCallbacks".
      *>------------------------------------------------------------
      *> PRIVATE. Callback used by getSignalHandlers
      *>------------------------------------------------------------
       Method-id. "addReceiver".

       local-storage section.
       01  lsReceiver                 object reference.

       linkage section.
       01  lnkCallback                object reference.
       01  lnkSignalHandlers          object reference.

       procedure division using lnkSignalHandlers lnkCallback.
           invoke lnkCallback "getReceiver" returning lsReceiver
           invoke lnkSignalHandlers "add" using lsReceiver
           exit method.
       end method "addReceiver".
      *>------------------------------------------------------------
      *> Disconnect a component from an output signal
      *>------------------------------------------------------------
       Method-id. "disconnectSignal".

       local-storage section.
       01  lsSignalHandlers           object reference.

       linkage section.
       01  lnkSignalId                pic x(32).
       01  lnkComponent               object reference.

       procedure division using lnkSignalId lnkComponent.
           invoke self "getOutputSignalCallbacks" using lnkSignalId
                                              returning lsSignalHandlers
           if lsSignalHandlers <> null
               invoke self "disconnectSignals" using lnkComponent
                                                     lsSignalHandlers
           end-if
           exit method.
       end method "disconnectSignal".
      *>------------------------------------------------------------
      *> PRIVATE. Returns a list of the components dependent on self
      *>------------------------------------------------------------
       Method-id. "getSignalDependents".
       local-storage section.
       01  lsPointer                  pointer.

       linkage section.
       01  lnkDependents              object reference.
       copy "compnent.cpy".

       procedure division returning lnkDependents.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           set lnkDependents to dependants
           exit method.
       end method "getSignalDependents".



      *>----------------------------------------------------------------
      *> Destroys the object to which this message is sent. The result
      *> is always set to null. Therefore invoke anObject "finalize"
      *> returning anObject. Will destroy anObject and set the reference
      *> to null.
      *>----------------------------------------------------------------
       method-id. "finalize".
       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.
       01 lsBool               pic x comp-5.
          88 isTrue            value 1.
          88 isFalse           value 0.
       01 lsFlag               pic x(4) comp-5.
       linkage section.
       01 result               usage object reference.

       procedure division returning result.
           if self equal to null
               move 27 to exceptionnumber
               invoke self "raiseException" using exceptionnumber
                                             returning result
           else
               set result to null

      *>> Note, instance data is not linked so must not access after
      *>> cancel.

               call "oopsgetpropertyflag" using by value self
                       by reference lsFlag
               if lsFlag > 0
                   invoke self "isComponent" returning lsBool
                   if isTrue
                       invoke self "disconnect"
                   end-if
               end-if
               call "oopscancel" using self
           end-if
           exit method.
       end method "finalize".
      *>----------------------------------------------------------------
      *> Report an error for this instance using ErrNumber. This will
      *> call a user defined exception handler if one has been
      *> registered.
      *>----------------------------------------------------------------
       method-id. "raiseException".
       local-storage section.
       01 lsResult             usage object reference.
       01 nulobjref            usage object reference.

       linkage section.
       01 result               usage object reference.
       01 errnumber            pic x(4) comp-5.

       procedure division using errnumber returning result.
           if address of result = null
               set address of result to address of lsResult
           end-if
           set nulobjref to null
           if self equal to null
               invoke ExceptionManager "raisestatic" using selfclass
                                                           errnumber
                                                           nulobjref
                                                 returning result
           else
               invoke ExceptionManager "raise" using self errnumber
                                                           nulobjref
                                                    returning result
           end-if
           exit method.
       end method "raiseException".
      *>----------------------------------------------------------------
      *> Destroy this object, and all the elements in it up to a depth
      *> lnkDepth.
      *>----------------------------------------------------------------
       method-id. "deepfinalizeWithDepth".
       linkage section.
       01 lnkDepth             pic x(4) comp-5.
       01 defaultreturn        usage object reference.

       procedure division using lnkDepth returning defaultreturn.
           invoke self "finalize" returning defaultReturn
           exit method.
       end method "deepfinalizeWithDepth".


      *>----------------------------------------------------------------
      *> Destroy this object, and all the elements in it up to a depth
      *> 1.
      *>----------------------------------------------------------------
       method-id. "deepfinalize".
       local-storage section.
       01 lsDepth              pic x(4) comp-5.
       linkage section.
       01 defaultreturn        usage object reference.

       procedure division returning defaultreturn.
           move 1 to lsDepth
           invoke self "deepfinalizeWithDepth" using lsDepth
                            returning defaultReturn
           exit method.
       end method "deepfinalize".
      *>----------------------------------------------------------------
      *> Destroy this object, and all the elements .
      *>----------------------------------------------------------------
       method-id. "reallydeepfinalize".
       local-storage section.
       01 lsDepth              pic x(4) comp-5.
       linkage section.
       01 defaultreturn        usage object reference.

       procedure division returning defaultreturn.
           move h"FFFFFFFF" to lsDepth
           invoke self "deepfinalizeWithDepth" using lsDepth
                            returning defaultReturn
           exit method.
       end method "reallydeepfinalize".

      *>----------------------------------------------------------------
      *> Return the base message File handler.
      *>----------------------------------------------------------------
       method-id. "registerBaseMessageFile".
       local-storage section.
       01 OS-Info-Param-Block.
           03  Parameter-Size         PIC X(2) COMP-X.
           03  P-OS-Type              PIC X    COMP-X.
           03  p-os-version           PIC X(4) comp-x.
           03  p-dbcs-support         pic x    comp-x.
           03  filler                 pic x(10).

       linkage section.
       01 msgfh                  usage object reference.

       procedure division returning msgfh.
           move length of OS-Info-Param-Block to parameter-size
           CALL "CBL_GET_OS_INFO" USING OS-Info-Param-Block
           if p-os-type = 128 *>> On Unix           
                invoke MessageFileHandler "registerMessageFileZ" using
                                x"00"
                                z"oocobol.lng"
                                returning msgfh
           else
                invoke MessageFileHandler "registerMessageFileZ" using
                                x"00"
                                z"OOCOBOL.ERR"
                                returning msgfh

           end-if
           exit method.
       end method "registerBaseMessageFile".

      *>----------------------------------------------------------------
      *> Return a string which contains the description of this object.
      *>----------------------------------------------------------------
       method-id. "description".
       local-storage section.
       01 i                        pic x(4) comp-5.
       01 j                        pic x(4) comp-5.
       01 description              object reference.
       01 lsmsgfh                  object reference.
       01 string1                  object reference.
       linkage section.
       01 aString                  usage object reference.
       procedure division returning aString.
           invoke self "registerBaseMessageFile"
                                returning lsmsgfh
           move 2 to i
           if self equal to null
               move 1 to j
               *>> LNG 1: "A static instance of %s"
           else
               move 2 to j
               *>> LNG 2: "An instance of %s"
           end-if
           invoke selfclass "Description" returning string1
           invoke lsmsgfh "getmessage" using i j string1
                    returning astring
           invoke string1 "finalize" returning string1
           invoke lsmsgfh "finalize" returning lsmsgfh
           exit method.
       end method "description".
      *>----------------------------------------------------------------
      *> Return the classname of this instance.
      *>----------------------------------------------------------------
       method-id. "className".
       linkage section.
       01 aString              usage object reference.
       procedure division returning aString.
           invoke selfclass "name" returning aString
           exit method.
       end method "className".
      *>----------------------------------------------------------------
      *> Display the recursive message for a recursive message.
      *>----------------------------------------------------------------

       method-id. "displayRecursion".
       local-storage section.
       01 aString                  usage object reference.
       01 i                        pic x(4) comp-5.
       01 j                        pic x(4) comp-5.
       01 lsmsgfh                  object reference.
       01 string1                  object reference.
       procedure division.
           invoke self "registerBaseMessageFile"
                                returning lsmsgfh
           *>> LNG 3: "...recursive reference to %s ..."
           invoke self "description" returning string1
           move 2 to i
           move 3 to j
           invoke lsmsgfh "getmessage" using i j string1
                    returning astring
           invoke aString "display"
           invoke string1 "finalize" returning string1
           invoke aString "finalize" returning aString
           invoke lsmsgfh "finalize" returning lsmsgfh
           exit method.
       end method "displayRecursion".
      *>----------------------------------------------------------------
      *> Display the value of the receiver. The default behaviour is to
      *> display the description of the receiver.
      *>----------------------------------------------------------------
       method-id. "display".
       local-storage section.
       01 aString      usage object reference.
       procedure division.
           invoke self "description" returning aString
           invoke aString "display"
           invoke aString "finalize" returning aString
           exit method.
       end method "display".
      *>----------------------------------------------------------------
      *> Return a shallow copy of the receiver
      *>----------------------------------------------------------------
       method-id. "basicCopy".
       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.

       linkage section.
       01 result               usage object reference.

       procedure division returning result.
           if self equal to null
               move 27 to exceptionnumber
               invoke self "raiseException" using exceptionnumber
                                             returning result
           else
               call "oopsshallowcopy" using self returning result
           end-if
           exit method.
       end method "basicCopy".

      *>----------------------------------------------------------------
      *> Copy contents of this object into lnkObject.
      *> Returns true if the operation succeeded. Returns false if
      *> operation failed. May return false if the objects are of
      *> different sizes, or if this is an invalid operation for some
      *> objects.
      *>----------------------------------------------------------------

       method-id. "copyContents".
       local-storage section.
       01 result               pic x(4) comp-5.
       linkage section.
       01 lnkObject            usage object reference.
       01 lnkBool              pic x comp-5.
       procedure division using lnkObject
                        returning lnkBool.
           call "oopscopyobjectcontents" using by value self
                                               by value lnkObject
                                returning result
           if result = 0
                move zero to lnkBool
           else
                move 1 to lnkBool
           end-if
           exit method.
       end method "copyContents".

      *>----------------------------------------------------------------
      *> Return a shallow copy of the receiver. This method can be
      *> overridden but it is advised you do not override the method
      *> basicCopy.
      *>----------------------------------------------------------------
       method-id. "copy".
       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.

       linkage section.
       01 result               usage object reference.

       procedure division returning result.
           if self equal to null
               move 27 to exceptionnumber
               invoke self "raiseException" using exceptionnumber
                                             returning result
           else
               call "oopsshallowcopy" using self returning result
           end-if
           exit method.
       end method "copy".
      *>----------------------------------------------------------------
      *> Raises an exception as receiver does not understand the message
      *> sent to it. You would not normally raise this message directly.
      *> However you can override it to change the default behavior.
      *>----------------------------------------------------------------
       method-id. "doesNotUnderstand".
       working-storage section.
       01 anErrorMessage       pic x(160).

       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.
       01 aDelegate            usage object reference.
       01 tmpObject            usage object reference.
       01 anerrorclassname     pic x(30).

       linkage section.
       01 p1       pic x.
       01 p2       pic x.
       01 p3       pic x.
       01 p4       pic x.
       01 p5       pic x.
       01 p6       pic x.
       01 p7       pic x.
       01 result   pic x.
       procedure division using p1 p2 p3 p4 p5 p6 p7 returning result.
           invoke delegateManager "getDelegateFor" using self
               returning aDelegate
           if aDelegate = null
               move 24 to exceptionnumber
               invoke self "raiseException" using exceptionnumber
                               returning tmpObject
           else
               move spaces to anerrormessage
               call "oopserrordetails" using self,
                                         anerrorclassname,
                                         anerrormessage
               invoke aDelegate anErrorMessage using p1 p2 p3 p4
                            p5 p6 p7 returning result
           exit method.
       end method "doesNotUnderstand".
      *>----------------------------------------------------------------
      *> PRIVATE. Save the data for the receiver to file
      *>----------------------------------------------------------------
       method-id. "suspend".
       working-storage section.
       01 persistManagerForThisRunUnit usage object reference
                        is external by "oopssavepersistref".

       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.

       linkage section.
       01 objectdetails.
           03 objhandle        usage object  reference.
           03 objsize          pic x(4) comp-5.
           03 objaddress       pointer.
       01 lnkSavedFlag         pic x comp-5.
           88 isSaved          value 1.
           88 isNotSaved       value 0.

       procedure division using objectdetails returning lnkSavedFlag.
           if persistManagerForThisRunUnit = persistenceManager
                invoke self "prepareToBeSaved"
                if self equal to null
                    set isNotSaved to true
                    move 27 to exceptionnumber
                    invoke self "raiseException" using exceptionnumber
                 else
                    if objsize not = zero
                       invoke persistencemanager "write"
                                using objectdetails
                    end-if
                    set isSaved to true
                end-if
           else
                set isNotSaved to true
           end-if
           exit method.
       end method "suspend".
      *>----------------------------------------------------------------
      *> Return the class of the receiver
      *>----------------------------------------------------------------
       method-id. "class".
       linkage section.
       01 result               usage object reference.

       procedure division returning result.
           set result to selfclass
           exit method.
       end method "class".
      *>----------------------------------------------------------------
      *> PRIVATE. Load pre-saved data from file. This should not be
      *> included as a class method.
      *>----------------------------------------------------------------
       method-id. "resume".
       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.

       linkage section.
       01 objectdetails.
           03 objhandle        pic x(4) comp-5.
           03 objsize          pic x(4) comp-5.
           03 objaddress       pointer.

       procedure division using objectdetails.
           if self equal to null
               move 27 to exceptionnumber
               invoke self "raiseException" using exceptionnumber
           else
               if objsize not = zero
                  invoke persistencemanager "read" using objectdetails
               end-if
           end-if
           invoke self "reset"
           exit method.
       end method "resume".
      *>----------------------------------------------------------------
      *> Return a hash value for the receiver. Objects which are
      *> equal should return the same hash value.
      *>----------------------------------------------------------------
       method-id. "hash".
       linkage section.
       01 ahashvalue pic s9(9) comp-5.
       01 hashresult redefines ahashvalue usage object reference.
       01 result               usage object reference.

       procedure division returning ahashvalue.
           if self equal to null
               invoke self "implementedBySubClass" returning result
               exit method
           end-if
           set hashresult to self
           if ahashvalue < 0
               compute ahashvalue =  - ahashvalue
           end-if
           exit method.
       end method "hash".
      *>----------------------------------------------------------------
      *> Answer true if the receiver is sequenced, else answer false.
      *>----------------------------------------------------------------
       method-id. "isSequenced".
       linkage section.
       01 lnkbool                pic x comp-5.

       procedure division returning lnkbool.
           move 0 to lnkbool
           exit method.
       end method "isSequenced".
      *>----------------------------------------------------------------
      *> Answer true if the receiver is the desktop otherwise return
      *> false.
      *>----------------------------------------------------------------
       method-id. "isDesktop".
       linkage section.
       01 Bool             pic x comp-5.
       procedure division returning bool.
           move 0 to bool
           exit method.
       end method "isDesktop".
      *>----------------------------------------------------------------
      *> Determine whether an object is equal to another object.
      *> The default behavior for this method is to determine whether
      *> they are identical.
      *>----------------------------------------------------------------
       method-id. "equal".
       linkage section.
       01 lnkbool                  pic x comp-5.
           88 istrue               value 1.
           88 isfalse              value 0.
       01 anobject                 usage object reference.

       procedure division using anobject returning lnkbool.
           if self equal to null
               invoke self "implementedBySubclass" returning lnkbool
           else
               if self equal to anobject
                   set istrue to true
               else
                   set isfalse to true
               end-if
           end-if
           exit method.
       end method "Equal".
      *>----------------------------------------------------------------
      *> PRIVATE. Raise an exception as a message has been intercepted
      *> by a class when it should have been implemented by a subclass.
      *>----------------------------------------------------------------
       method-id. "implementedBySubClass".
       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.

       linkage section.
       01 result               usage object reference.

       procedure division returning result.
           move 7 to exceptionnumber
           invoke self "raiseException" using exceptionnumber
                                         returning result
           exit method.
       end method "implementedBySubClass".
      *>----------------------------------------------------------------
      *> PRIVATE. Raise an exception as a message has been sent to an
      *> object when that object should not implement it.
      *>----------------------------------------------------------------
       method-id. "shouldNotImplement".
       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.

       linkage section.
       01 result               usage object reference.

       procedure division returning result.
           move 16 to exceptionnumber
           invoke self "raiseException" using exceptionnumber
                                         returning result
           exit method.
       end method "shouldNotImplement".
      *>----------------------------------------------------------------
      *> Return the class of the receiver as the default implementation
      *> of species.
      *>----------------------------------------------------------------
       method-id. "species".
       linkage section.
       01 lnkClass             usage object reference.
       procedure division returning lnkClass.
           set lnkClass to selfClass
           exit method.
       end method "species".
      *>----------------------------------------------------------------
      *> PRIVATE. Raise an exception as a parameter is invalid.
      *>----------------------------------------------------------------
       method-id. "invalidParameter".
       local-storage section.
       01 exceptionnumber      pic x(4) comp-5.

       linkage section.
       01 result               usage object reference.

       procedure division returning result.
           move 33 to exceptionnumber
           invoke self "raiseException" using exceptionnumber
                                         returning result
           exit method.
       end method "invalidParameter".
      *>----------------------------------------------------------------
      *> Specify an object (aDelegate) that acts as the delegate for
      *> this object if the message is not understood
      *>----------------------------------------------------------------

       method-id. "setDelegate".
       linkage section.
       01 aDelegate        usage object reference.

       procedure division using aDelegate.
           invoke delegateManager "addDelegateFor" using self aDelegate
           exit method.
       end method "setDelegate".
      *>----------------------------------------------------------------
      *> Remove any delegate for this object.
      *>----------------------------------------------------------------

       method-id. "removeDelegate".
       procedure division.
           invoke delegateManager "remove" using self
           exit method.
       end method "removeDelegate".
      *>----------------------------------------------------------------
      *> PRIVATE. Delete this object from the persistent store.
      *>----------------------------------------------------------------

       method-id. "cancel".
       linkage section.
       01 objectdetails.
           03 objhandle    pic x(4) comp-5.
           03 objsize      pic x(4) comp-5.
           03 objaddress   pointer.

       procedure division using objectdetails.
           invoke persistencemanager "delete" using objectdetails.
           exit method.
       end method "cancel".
      *>---------------------------------------------------------------
      *> Return true if this object is a type of popup otherwise return
      *> false.
      *>---------------------------------------------------------------
       method-id. "isPopUp".
       linkage section.
       01 lnkbool             pic x comp-5.
           88  lnkistrue      value 1.
           88  lnkisfalse     value 0.

       procedure division returning lnkbool.
           set lnkisfalse to true
           exit method.
       end method "isPopUp".
      *>---------------------------------------------------------------
      *> Return true if this object is a type of window otherwise
      *> return false.
      *>---------------------------------------------------------------
       method-id. "isWindow".
       linkage section.
       01 lnkbool             pic x comp-5.
           88  lnkistrue      value 1.
           88  lnkisfalse     value 0.

       procedure division returning lnkbool.
           set lnkisfalse to true
           exit method.
       end method "isWindow".
      *>---------------------------------------------------------------
      *> Return true if this object is a type of menubar otherwise
      *> return false.
      *>---------------------------------------------------------------
       method-id. "isMenubar".
       linkage section.
       01 lnkbool             pic x comp-5.
           88  lnkistrue      value 1.
           88  lnkisfalse     value 0.

       procedure division returning lnkbool.
           set lnkisfalse to true
           exit method.
       end method "isMenubar".
      *>---------------------------------------------------------------
      *> Return true if this object can be a parent of a menu.
      *>---------------------------------------------------------------
       method-id. "isMenuParent".
       linkage section.
       01 lnkbool             pic x comp-5.
           88  lnkistrue      value 1.
           88  lnkisfalse     value 0.

       procedure division returning lnkbool.
           set lnkisfalse to true
           exit method.
       end method "isMenuParent".
      *>------------------------------------------------------------
      *> Respond true if output signal lnkSignalId is defined for
      *> this component.
      *>------------------------------------------------------------
       Method-id. "isOutputSignal".
       local-storage section.
       01  lsSignalHandlerList        object reference.
       01  lsSignalId                 pic x(32).
       01  lsPointer                  pointer.
       01  i                          pic s9(9) comp-5.

       linkage section.
       01  lnkSignalId                pic x(32).
       copy "compnent.cpy".
       01  lnkBool                    pic x comp-5.
           88 isTrue                  value 1.
           88 isFalse                 value 0.

       procedure division using lnkSignalId returning lnkBool.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           move spaces to lsSignalId
           perform varying i from 1 by 1
                   until lnkSignalId(i:1) = x"00"
                   or    lnkSignalId(i:1) = space
               move lnkSignalId(i:1) to lsSignalId(i:1)
           end-perform
           invoke outputs "atOrNil" using lsSignalId(1:32)
                                returning lsSignalHandlerList
           if lsSignalHandlerList = null
               set isFalse to true
           else
               set isTrue to true
           end-if
           exit method.
       end method "isOutputSignal".
      *>---------------------------------------------------------------
      *> Return true if this object is a process item.
      *>---------------------------------------------------------------
       method-id. "isProcessItem".
       linkage section.
       01 lnkbool             pic x comp-5.
           88  lnkistrue      value 1.
           88  lnkisfalse     value 0.

       procedure division returning lnkbool.
           set lnkisfalse to true
           exit method.
       end method "isProcessItem".
      *>---------------------------------------------------------------
      *> Return true if this object is a submenu.
      *>---------------------------------------------------------------
       method-id. "isSubMenu".
       linkage section.
       01 lnkbool             pic x comp-5.
           88  lnkistrue      value 1.
           88  lnkisfalse     value 0.

       procedure division returning lnkbool.
           set lnkisfalse to true
           exit method.
       end method "isSubMenu".
      *>---------------------------------------------------------------
      *> Default is to do nothing but return true so other idle
      *> interested parties can be called.
      *>---------------------------------------------------------------
       method-id. "doIdleProcessing".
       linkage section.
       01 lnkbool               pic x comp-5.
           88  lnkistrue        value 1.
           88  lnkisfalse       value 0.

       procedure division returning lnkbool.
           set lnkistrue to true
           exit method.
       end method "doIdleProcessing".
      *>--------------------------------------------------------------
      *> Allocate a new piece of memory which is lnkSize byes large,
      *> and return a pointer to it in lnkPtr.
      *>--------------------------------------------------------------
       method-id. "malloc".
       linkage section.
       01 lnkSize           pic x(4) comp-5.
       01 lnkPtr            usage pointer.

       procedure division using lnkSize returning lnkPtr.
           call "oopsallocmemory" using by value lnkSize
                                  returning lnkPtr
           exit method
       end method "malloc".
      *>----------------------------------------------------------------
      *> Deallocate memory pointed to by lnkPtr. This memory must have
      *> been allocated using malloc method.
      *>----------------------------------------------------------------
       method-id. "dealloc".
       linkage section.
       01 lnkPtr            usage pointer.
       procedure division using lnkPtr.
           call "oopsfreememory" using by value lnkPtr
           exit method.
       end method "dealloc".

      *>----------------------------------------------------------------
      *> By default prepareToBeSaved will do nothing. This is sent to
      *> each object immediately before it is saved to disk. To do
      *> anything useful a user must subclass and override this method.
      *>----------------------------------------------------------------
       method-id. "prepareToBeSaved".
       procedure division.
           exit method.
       end method "PrepareToBeSaved".
      *>----------------------------------------------------------------
      *> By default reset will do nothing. This is called before the
      *> first message is resolved to an object on a subsequent run.
      *> To do anything useful a user must subclass and override this
      *> method.
      *>----------------------------------------------------------------
       method-id. "reset".
       procedure division.
           exit method.
       end method "reset".
      *>----------------------------------------------------------------
      *> Change references to this object to point to lnkObject and
      *> vice versa. Care should be taken when invoking this method.
      *> It is not advised to send this message to a class or to send
      *> a class as a parameter.
      *>----------------------------------------------------------------
       method-id. "becomes".
       linkage section.
       01 lnkObject    usage object reference.
       procedure division using lnkObject.
           call "oopsbecomes" using self lnkObject
       end method "becomes".
      *>---------------------------------------------------------------
      *> Return the length of the object handle for any instance. This
      *> is mainly used for collections of intrinsic objects.
      *>---------------------------------------------------------------
       method-id. "size".
       linkage section.
       01 alength              pic x(4) comp-5.

       procedure division returning alength.
           move objectReferenceSize to alength
           exit method.
       end method "size".
      *>---------------------------------------------------------------
      *> Return the length of the object handle for any instance. This
      *> is mainly used for collections of intrinsic objects.
      *>---------------------------------------------------------------
       method-id. "sizeInBytes".
       linkage section.
       01 alength              pic x(4) comp-5.

       procedure division returning alength.
           invoke self "size" returning alength
           exit method.
       end method "sizeInBytes".
      *>----------------------------------------------------------------
      *> Sending this message will cause all objects to receive the
      *> prepareToBeSaved message and they will be saved to disk.
      *>----------------------------------------------------------------

       method-id. "SaveEveryThing".
       working-storage section.
       01 persistManagerForThisRunUnit usage object reference
                        is external by "oopssavepersistref".
       procedure division.
           set persistManagerForThisRunUnit to persistenceManager
           call "oopssuspend"
       end method "SaveEveryThing".
      *>--------------------------------------------------------------
      *> PRIVATE. Determine maximum levels of recursion
      *>--------------------------------------------------------------
       method-id. "levelsOfRecursion".
       working-storage section.
       01 i        pic x(4) comp-5 value 1.

       procedure division.
           display i
           add 1 to i
           invoke self "levelsOfRecursion"
           exit method.
       end method "levelsOfRecursion".
      *>----------------------------------------------------------------
      *> Return the message this object did not understand. This should
      *> only be called for a user defined exception handler for the
      *> doesnotunderstand message otherwise, you may get unpredictable
      *> results.
      *>----------------------------------------------------------------
       method-id. "whatdidntIUnderstand".
       local-storage section.
       01 anerrorclassname     pic x(30).
       01 anErrorMessage       pic x(160).
       linkage section.
       01 lnkString  usage object reference.
       procedure division returning lnkString.
           call "oopserrordetails" using self,
                                         anerrorclassname,
                                         anerrormessage
           invoke CharacterArray "withSpaceTerminator"
                            using anErrorMessage
                       returning lnkString
           exit method.
       end method "whatdidntIUnderstand".

      *>------------------------------------------------------------
      *> PRIVATE. Initialize the component sockets and output.
      *>------------------------------------------------------------
       Method-id. "becomeComponent".
       working-storage section.
       01  wsExceptionMethod         object reference value null.
       local-storage section.
       01  lsPointer                 pointer.
       01  i                         pic s9(9) comp-5.

       linkage section.
       copy "compnent.cpy".

       procedure division.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           invoke self "isSignalTracing" returning tracingFlag
           move numberOfStandardOutputs to i
           invoke IdentityDictionary "ofValues"
                                       using picXToObject
                                             i
                                       returning outputs
           move numberOfStandardSockets to i
           invoke IdentityDictionary "ofValues"
                                       using picXToObject
                                             i
                                       returning sockets
           move numberofStandardDependants to i
           invoke IdentitySet "ofReferences"
                                       using i
                                       returning dependants
           move numberofStandardSpies to i
           invoke OrderedCollection "ofReferences"
                                       using i
                                       returning spies
           set duplicatesOK to true
           if wsExceptionMethod = null
               invoke Callback "new" using self "componentException "
                             returning wsExceptionMethod
           end-if
           invoke ExceptionManager "register" using self
                                          wsExceptionMethod
           call "oopssetpropertyflag" using by value self
                                            by value 1 size 4
           exit method.
       end method "becomeComponent".
      *>------------------------------------------------------------
      *> Defines an input signal for this component, so lnkMethodName
      *> is invoked automatically whenever another component sends the
      *> signal lnkSignalId on the socket lnkSocketid.
      *> You must invoke the methods "makeComponent" and
      *> "defineInSocket" to make an object into a component and define
      *> an input socket for it before you can define any input signals.
      *> You must also invoke the method "connect" after defining all
      *> input and output signals, to connect two components together
      *> before they can send signals to each other.
      *> For more information on Components and Signals, see the
      *> file compnent.txt
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       Method-id. "defineInSignal".
       local-storage section.
       01  lsCallback                  object reference.
       01  lsClassName                 object reference.
       01  lsClassNameText             pic x(64).
       01  lsSignalId                  pic x(32).
       01  lsSocketId                  pic x(32).
       01  lsSocket                    object reference.
       01  i                           pic s9(9) comp-5.
       01  lsPointer                   pointer.
       01  lserrorstring1              object reference.
       01  lserrorstring2              object reference.

       linkage section.
       01  lnkSignalId                 pic x(32).
       01  lnkSocketId                 pic x(32).
       01  lnkMethodName               pic x(32).
       copy "compnent.cpy".

       procedure division using lnkSignalId,
                                lnkSocketId,
                                lnkMethodName.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           move spaces to lsSocketId
           perform varying i from 1 by 1
                   until lnkSocketId(i:1) = x"00"
                   or    lnkSocketId(i:1) = space
               move lnkSocketId(i:1) to lsSocketId(i:1)
           end-perform
           move spaces to lsSignalId
           perform varying i from 1 by 1
                   until lnkSignalId(i:1) = x"00"
                   or    lnkSignalId(i:1) = space
               move lnkSignalId(i:1) to lsSignalId(i:1)
           end-perform
           invoke sockets "atOrNil"
                               using lsSocketId
                           returning lsSocket
           if signalTracing
               invoke self "className" returning lsClassName
               move low-values to lsClassNameText
               invoke lsClassName "getValue"
                   returning lsClassNameText
               writetrace with "Defining input signal "
                               lsSignalId(1:32)
                               " on "
                               lsSocketId(1:32)
                               " for "
                               lsClassNameText
           end-if
           if lsSocket <> null
               invoke lsSocket "atOrNil" using lsSignalId(1:32)
                                     returning lsCallback
               if lsCallBack = null
                   invoke Callback "new" using self lnkMethodName
                                     returning lsCallback
                   invoke lsSocket "atPut" using lsSignalId(1:32)
                                             lsCallback
               else if not duplicatesOK
                   move 32 to i
                   invoke characterarray "withlengthvalue"
                        using i lsSignalID
                        returning lserrorstring1
                   invoke characterarray "withlengthvalue"
                        using i lsSocketID
                        returning lserrorstring2
                   invoke self "raiseexceptionwithtext"
                        using duplicateInputSignal
                        lserrorstring1
                        lserrorstring2
               end-if
           else
               invoke CharacterArray "withSpaceOrNullTerminator"
                        using lsSocketId
                        returning lserrorstring1
               invoke self "raiseexceptionwithtext"
                        using inputSocketUndefined
                        lserrorstring1
           end-if
           exit method.
       end method "defineInSignal".
      *>------------------------------------------------------------
      *> Defines an output signal for this component. The name of
      *> the output signal lnkSignalId must be a space- or null-
      *> terminated name of 32 characters or less.
      *> You must invoke the method "makeComponent" to make an object
      *> into a component before you can define any output signals.
      *> You must also invoke the method "connect" after defining all
      *> input and output signals, to connect two components together
      *> before they can send signals to each other.
      *> For more information on Components and Signals see the file
      *> compnent.txt
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       Method-id. "defineOutSignal".
       local-storage section.
       01  lsSignalHandlerList        object reference.
       01  lsStandardSignalChainSize  pic s9(9) comp-5.
       01  lsSignalId                 pic x(32).
       01  i                          pic s9(9) comp-5.
       01  lsStandardOutputs          pic s9(9) comp-5.
       01  lsClassName                object reference.
       01  lsClassNameText            pic x(64).
       01  lsPointer                  pointer.
       01  lserrorstring              object reference.

       linkage section.
       01  lnkSignalId                pic x(32).
       copy "compnent.cpy".

       procedure division using lnkSignalId.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           move spaces to lsSignalId
           perform varying i from 1 by 1
                   until lnkSignalId(i:1) = x"00"
                   or    lnkSignalId(i:1) = space
               move lnkSignalId(i:1) to lsSignalId(i:1)
           end-perform
           invoke outputs "atOrNil" using lsSignalId(1:32)
                                returning lsSignalHandlerList
           if lsSignalHandlerList = null
               move numberOfHandlersForSignal
               to   lsStandardSignalChainSize
               invoke OrderedCollection "ofReferences"
                                       using lsStandardSignalChainSize
                                   returning lsSignalHandlerList
               if signalTracing
                   invoke self "className" returning lsClassName
                   move low-values to lsClassNameText
                   invoke lsClassName "getValue"
                       returning lsClassNameText
                   writetrace with "Defining output signal "
                                   lsSignalId(1:32)
                                   " for "
                                   lsClassNameText
               end-if
                   invoke outputs "atPut" using lsSignalId(1:32)
                                                lsSignalHandlerList
           else if not duplicatesOK
               invoke CharacterArray "withSpaceOrNullTerminator"
                        using lsSignalId
                        returning lserrorstring
               invoke self "raiseExceptionWithText"
                        using duplicateOutputSignal
                        lserrorstring
           end-if
           exit method.
       end method "defineOutSignal".
      *>------------------------------------------------------------
      *> Set up a handler to translate a physical event on an object
      *> to a logical signal.
      *> Need to use standard event handler but make the callback
      *> invoke signal specifying signalId and pass parameter if
      *> provided
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       Method-id. "translateEventToSignal".

       local-storage section.
       01  lsSignalString       object reference.

       linkage section.
       01  lnkEventId           pic s9(9) comp-5.
       01  lnksignalObject      object reference.
       01  lnkSignalId          pic x(32).
       01  lnkParameter         object reference.

       procedure division using lnkEventId
                                lnkSignalObject
                                lnkSignalId
                                lnkParameter.
           invoke CharacterArray "withSpaceOrNullTerminator"
                     using lnkSignalId returning lsSignalString
           invoke self "setEventTo" using lnkEventId
                                          lnkSignalObject
                                          "signalString "
                                          lsSignalString
                                          lnkParameter
           exit method.
       end method "translateEventToSignal".
      *>------------------------------------------------------------
      *> Defines an input socket for this component with socket id
      *> lnkSocketId. lnkSocketId must be a space- or null-terminated
      *> name which uniquely identifies the socket.
      *> You must invoke the method "makeComponent" to make an object
      *> into a component before you can define an input socket for it.
      *> For more information on Components and Signals see the
      *> file compnent.txt
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       Method-id. "defineInSocket".

       local-storage section.
       01  lsSocketConnections        object reference.
       01  lsStartingSocketSize       pic s9(9) comp-5.
       01  lsAssociation              usage object reference.
       01  lsSocketId                 pic x(32).
       01  i                          pic s9(9) comp-5.
       01  lsStandardSockets          pic s9(9) comp-5.
       01  lsClassName                object reference.
       01  lsClassNameText            pic x(64).
       01  lsPointer                  pointer.

       linkage section.
       01  lnkSocketId                pic x(32).
       copy "compnent.cpy".

       procedure division using lnkSocketId.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           move spaces to lsSocketId
           perform varying i from 1 by 1
                   until lnkSocketId(i:1) = x"00"
                   or    lnkSocketId(i:1) = space
               move lnkSocketId(i:1) to lsSocketId(i:1)
           end-perform
           move numberOfSocketSignals to lsStartingSocketSize
           invoke sockets "atOrNil" using lsSocketId
                        returning lsSocketConnections
           if lsSocketCOnnections = null
                invoke IdentityDictionary "ofValues"
                                           using picXToObject
                                                 lsStartingSocketSize
                                       returning lsSocketConnections
                if signalTracing
                    invoke self "className" returning lsClassName
                    move low-values to lsClassNameText
                    invoke lsClassName "getValue"
                       returning lsClassNameText
                    writetrace with "Defining input socket "
                               lsSocketId(1:32)
                               " for "
                               lsClassNameText
                end-if
                invoke sockets "atPut" using lsSocketId
                                        lsSocketConnections
           end-if
           exit method.
       end method "defineInSocket".
      *>------------------------------------------------------------
      *> Connects the outputs of outputComponent to socket lnksocketID
      *> of inputComponent.
      *>
      *> You can connect an output component to any number of input
      *> sockets. Any input socket can be connected to the output of
      *> more than one component.
      *> Before you attempt to connect two components together you must
      *> first invoke the methods "makeComponent" on both components
      *> to make them into components, and invoke "defineOutSignal on
      *> the lnkOutputComponent to define all the signals it will want
      *> to send, and also invoke "defineInSocket" and "defineInSignal"
      *> on lnkInputComponent to define its input signals.
      *> For more information on Components and Signals see the
      *> file compnent.txt
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *------------------------------------------------------------
       Method-id. "connect".

       local-storage section.
       01  lsOutputs                  object reference.
       01  lsMessage                  object reference.
       01  lsSocketId                 object reference.
       01  lsOutputComponent          object reference.
       01  lsInputComponent           object reference.
       01  lsSocketPicX               pic x(32).
       01  lsOutputPicX               pic x(64).
       01  lsInputPicX                pic x(64).
       01  lsPointer                  pointer.

       linkage section.
       01  lnkOutputComponent         object reference.
       01  lnkInputComponent          object reference.
       01  lnkSocketId                pic x(32).
       copy "compnent.cpy".

       procedure division using lnkOutputComponent,
                                lnkInputComponent,
                                lnkSocketId.
           invoke lnkOutputComponent "getInstanceData"
                             returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           invoke CharacterArray "withSpaceOrNullTerminator"
                     using lnkSocketId returning lsSocketId
           invoke lnkOutputComponent "getOutputs" returning lsOutputs
           invoke Callback "new" using lnkOutputComponent
                                       "copyConnection "
                                       lnkInputComponent
                                       lsSocketId
                             returning lsMessage
           if signalTracing
               invoke lnkOutputComponent "className"
                   returning lsOutputComponent
               move low-values to lsOutputPicX
               invoke lsOutputComponent "getValue"
                   returning lsOutputPicX
               invoke lnkInputComponent "className"
                   returning lsInputComponent
               move low-values to lsInputPicX
               invoke lsInputComponent "getValue"
                   returning lsInputPicX
               move low-values to lsSocketPicX
               invoke lsSocketId "getValue"
                   returning lsSocketPicX
               writetrace with "Connecting "
                               lsOutputPicX
                               " to "
                               lsInputPicX
                               " at socket "
                               lsSocketPicX
           end-if
           invoke lsOutputs "keysAndDataDo" using lsMessage
           invoke lsMessage "finalize" returning lsMessage
           invoke lsSocketId "finalize" returning lsSocketId
           exit method.
       end method "connect".
      *>------------------------------------------------------------
      *> Connects the outputs of the receiver to socket lnksocketID
      *> of inputComponent.
      *> You can connect an output component to any number of input
      *> sockets. Any input socket can be connected to the output of
      *> more than one component.
      *> Before you attempt to connect two components together you must
      *> first invoke the methods "makeComponent" on both components
      *> to make them into components, and invoke "defineOutSignal on
      *> the output component to define all the signals it will want
      *> to send, and also invoke "defineInSocket" and "defineInSignal"
      *> on lnkInputComponent to define its input signals.
      *> For more information on Components and Signals see the
      *> file compnent.txt
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       Method-id. "connectTo".

       linkage section.
       01  lnkInputComponent          object reference.
       01  lnkSocketId                pic x(32).

       procedure division using lnkInputComponent,
                                lnkSocketId.
           invoke self "connect" using self lnkInputComponent,
                                lnkSocketId
           exit method.
       end method "connectTo".
      *>------------------------------------------------------------
      *> PRIVATE. Iterator
      *> Connects the outputs of outputComponent to socket socketID
      *> of inputComponent.
      *>
      *> Connect one component to another by copying callbacks from the
      *> socketID Identity Dictionary of the inputComponent
      *> to the OrderedCollection of the output socket of
      *> outputComponent
      *------------------------------------------------------------
       Method-id. "copyConnection".

       local-storage section.
       01  lsCallback                 object reference.
       01  lsCallbackCopy             object reference.
       01  lsSocket                   object reference.
       01  lsSocketId                 pic x(32).
       01  lsClassName                object reference.
       01  lsClassNameText            pic x(64).
       01  lsPointer                  pointer.
       01  lsBool                     pic x comp-5.
           88 isTrue                  value 1.
           88 isFalse                 value 0.
       01  lserrorstring              object reference.

       linkage section.
       01  lnkSignalId                pic x(32).
       01  lnkSignalHandlers          object reference.
       01  lnkInputComponent          object reference.
       01  lnkSocketId                object reference.
       copy "compnent.cpy".

       procedure division using lnkInputComponent
                                lnkSocketId
                                lnkSignalId
                                lnkSignalHandlers.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           move spaces to lsSocketId
           invoke lnkSocketId "getValue" returning lsSocketId
           if signalTracing
               invoke lnkInputComponent "className"
                   returning lsClassName
               move low-values to lsClassNameText
               invoke lsClassName "getValue" returning lsClassNameText
               writetrace with "Connecting "
                               lnkSignalId(1:32)
                               " to "
                               lsClassNameText
                               " at socket "
                               lsSocketId
           end-if
           invoke lnkInputComponent "getSocket" using lsSocketId
                                            returning lsSocket
           if lsSocket <> null
               invoke lsSocket "atOrNil" using lnkSignalId
                                     returning lsCallback
               if lsCallback <> null
                   if lnkSignalHandlers <> null
                       invoke lnkSignalHandlers "includes"
                                                  using lsCallback
                                              returning lsBool
                       if isfalse
                           invoke lsCallback "copy"
                                         returning lsCallbackCopy
                           invoke lnkSignalHandlers "addLast"
                                             using lsCallbackCopy
                           invoke lnkInputComponent
                               "addSignalDependant"
                                             using self
                       end-if
                   else
                       raise exception internalError
                   end-if
               end-if
           else
               invoke CharacterArray "withSpaceOrNullTerminator"
                        using lsSocketId
                        returning lserrorstring
               invoke self "raiseExceptionWithText"
                        using inputSocketUndefined
                        lserrorstring
           end-if
           exit method.
       end method "copyConnection".
      *>------------------------------------------------------------
      *> Sends the signal lnkSignalId to any components which are
      *> connected to this component.
      *> lnkSignalId is a space- or null-terminated string.
      *> Before you attempt to send a signal from a component, you
      *> must first define all its output signals and connect it
      *> to a component which can receive them using the methods
      *> "makeComponent", "defineOutSignal" and "connect".
      *> For more information on Components and Signals see the
      *> file compnent.txt
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       Method-id. "signal".
       local-storage section.
       01  lsClassName                 object reference.
       01  lsClassNameText             pic x(64).
       01  lsNoOfHandlers              pic s9(9) comp-5.
       01  lsSignalHandlerIndex        pic s9(9) comp-5.
       01  lsSignalHandlers            object reference.
       01  lsHandler                   object reference.
       01  lsSignalId                  pic x(32).
       01  lsString                    object reference.
       01  lsCallback                  object reference.
       01  i                           pic s9(9) comp-5.
       01  muteFlag                    pic s9(9) comp-5.
           88 notMuted                 value 0.
       01  lsPointer                   pointer.
       01  lserrorstring               object reference.

       linkage section.
       01  lnkSignalId                 pic x(32).
       01  lnkP1                       object reference.
       01  lnkP2                       object reference.
       01  lnkP3                       object reference.
       01  lnkP4                       object reference.
       01  lnkP5                       object reference.
       01  lnkP6                       object reference.
       01  lnkP7                       object reference.
       01  lnkP8                       object reference.
       01  lnkP9                       object reference.
       01  lnkP10                      object reference.
       01  lnkSignalReturnValue        object reference.
       copy "compnent.cpy".

       procedure division using lnkSignalId
                                lnkP1
                                lnkP2
                                lnkP3
                                lnkP4
                                lnkP5
                                lnkP6
                                lnkP7
                                lnkP8
                                lnkP9
                                lnkP10
                      returning lnkSignalReturnValue.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           move spaces to lsSignalId
           perform varying i from 1 by 1
                   until lnkSignalId(i:1) = x"00"
                   or    lnkSignalId(i:1) = space
               move lnkSignalId(i:1) to lsSignalId(i:1)
           end-perform
           set notMuted to true
           if spies <> null
               invoke spies "size" returning i
               if i > 0
                   invoke CharacterArray "withSpaceTerminator"
                                                     using lsSignalId
                                                 returning lsString
                   invoke Callback "new" using self
                                               "sendToSpy "
                                               lsString
                                               muteFlag
                                     returning lsCallback
                   invoke spies "do" using lsCallback
                   move 2 to i
                   invoke lsCallback "getParameter" using i
                                                returning muteFlag
               end-if
           end-if
           if outputs <> null
             if notMuted
               invoke outputs "atOrNil" using lsSignalId
                                returning lsSignalHandlers
               if lsSignalHandlers <> null
                  invoke lsSignalHandlers "size"
                      returning lsNoOfHandlers
                  if lsNoOfHandlers <> 0
                      move 1 to lsSignalHandlerIndex
                      perform with test after
                          varying lsSignalHandlerIndex from 1 by 1
                          until lsSignalHandlerIndex = lsNoOfHandlers
                             or lsNoOfHandlers = 0
                              invoke lsSignalHandlers "at"
                                     using lsSignalHandlerIndex
                                 returning lsHandler
                              if signalTracing
                                   invoke self "className"
                                               returning lsClassName
                                   move low-values to lsClassNameText
                                   invoke lsClassName "getValue"
                                               returning lsClassNameText
                                   writetrace with
                                               lsClassNameText
                                               " sending signal "
                                               lsSignalId(1:32)
                              end-if
                              invoke lsHandler "invoke"
                                           using lnkP1
                                                 lnkP2
                                                 lnkP3
                                                 lnkP4
                                                 lnkP5
                                                 lnkP6
                                                 lnkP7
                                                 lnkP8
                                                 lnkP9
                                                 lnkP10
                                       returning lnkSignalReturnValue
                              invoke lsSignalHandlers "size"
                                            returning lsNoOfHandlers
                      end-perform
                  end-if
               else
                   move 32 to i
                   invoke characterarray "withlengthvalue"
                        using i lsSignalId
                        returning lserrorstring
                   invoke self "raiseExceptionWithText"
                        using outputSignalUndefined
                        lserrorstring
               end-if
             end-if
           else
              raise exception outputSocketUninitialized
           end-if
           exit method.
       end method "signal".
      *>------------------------------------------------------------
      *> Sends the signal lnkSignalId to any components which are
      *> connected to this component.
      *> This method is similar to the "signal" method, except that
      *> lnkSignalId is a characterarray instead of a pic x(32).
      *> Before you attempt to send a signal from a component, you
      *> must first define all its output signals and connect it
      *> to a component which can receive them using the methods
      *> "makeComponent", "defineOutSignal" and "connect".
      *> For more information on Components and Signals see the
      *> file compnent.txt
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       Method-id. "signalString".
       local-storage section.
       01  lsSignalId                  pic x(32).

       linkage section.
       01  lnkSignalId                 object reference.
       01  lnkP1                       object reference.
       01  lnkP2                       object reference.
       01  lnkP3                       object reference.
       01  lnkP4                       object reference.
       01  lnkP5                       object reference.
       01  lnkP6                       object reference.
       01  lnkP7                       object reference.
       01  lnkP8                       object reference.
       01  lnkP9                       object reference.
       01  lnkP10                      object reference.
       01  lnkSignalReturnValue        object reference.

       procedure division using lnkSignalId, 
                                lnkP1
                                lnkP2
                                lnkP3
                                lnkP4
                                lnkP5
                                lnkP6
                                lnkP7
                                lnkP8
                                lnkP9
                                lnkP10
                      returning lnkSignalReturnValue.
           move spaces to lsSignalId
           invoke lnkSignalId "getValue" returning lsSignalId
           invoke self "signal" using lsSignalId, 
                                lnkP1
                                lnkP2
                                lnkP3
                                lnkP4
                                lnkP5
                                lnkP6
                                lnkP7
                                lnkP8
                                lnkP9
                                lnkP10
                      returning lnkSignalReturnValue
           exit method.
       end method "signalString".
      *>------------------------------------------------------------
      *> Spy on a component and define an object/method
      *> to be invoked when the component sends a signal.
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       Method-id. "addSpy".
       local-storage section.
       01  lsCallback                  object reference.
       01  lsPointer                   pointer.

       linkage section.
       01  lnkObject                   object reference.
       01  lnkMethod                   object reference.
       copy "compnent.cpy".

       procedure division using lnkObject lnkMethod.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           invoke Callback "new" using lnkObject
                                       lnkMethod
                             returning lsCallback
           invoke spies "add" using lsCallback
           exit method.
       end method "addSpy".
      *>------------------------------------------------------------
      *> Spy on a component and define a callback to be invoked
      *> when the component sends a signal.
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       Method-id. "addSpyCallback".
       local-storage section.
       01  lsPointer                   pointer.

       linkage section.
       01  lnkCallback                 object reference.
       copy "compnent.cpy".

       procedure division using lnkCallback.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           invoke spies "add" using lnkCallback
           exit method.
       end method "addSpyCallback".
      *>------------------------------------------------------------
      *> Remove a spy.
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       method-id. "removeSpy".

       Local-Storage Section.
       01  lsCallback              object reference.
       01  lsPointer               pointer.

       Linkage Section.
       01  lnkComponent            object reference.
       copy "compnent.cpy".

       procedure division using lnkComponent.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           invoke Callback "new" using self
                                       "removeSpyCallback "
                                       lnkComponent
                             returning lsCallback
           invoke spies "do" using lsCallback
           invoke lsCallback "finalize" returning lsCallback
           exit method.
       end method "removeSpy".
      *>------------------------------------------------------------
      *> Remove a spy CallBack.
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       method-id. "removeSpyCallback".

       Local-Storage Section.
       01  lsReceiver              object reference.
       01  lsPointer               pointer.

       Linkage Section.
       01  lnkCallback             object reference.
       01  lnkComponent            object reference.
       copy "compnent.cpy".

       procedure division using lnkComponent
                                lnkCallback.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           invoke lnkCallback "getReceiver" returning lsReceiver
           if lsReceiver = lnkComponent
               invoke spies "remove" using lnkCallback
               invoke lnkCallback "finalize" returning lnkCallback
           end-if
           exit method.
       end method "removeSpyCallback".
      *>------------------------------------------------------------
      *> PRIVATE.
      *>------------------------------------------------------------

       method-id. "sendToSpy".

       Local-Storage Section.

       Linkage Section.
       01  lnkSignalId            pic x(32).
       01  lnkCallback            object reference.
       01  muteFlag               pic s9(9) comp-5.

       procedure division using lnkSignalId muteFlag lnkCallback.
           invoke lnkCallback "invoke" using self
                                             lnkSignalId
                                             muteFlag
           exit method.
       end method "sendToSpy".
      *>------------------------------------------------------------
      *> PRIVATE. Return the sockets Dictionary
      *>------------------------------------------------------------
       Method-id. "getSocket".

       local-storage section.
       01  lsPointer               pointer.

       linkage section.
       01  lnkSocket               object reference.
       01  lnkSocketId             pic x(32).
       copy "compnent.cpy".

       procedure division using lnkSocketId
                      returning lnkSocket.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           if sockets <> null
               invoke sockets "atOrNil"
                                   using     lnkSocketId
                                   returning lnkSocket
           else
               raise exception inputSocketUndefined
           end-if
           exit method.
       end method "getSocket".
      *>------------------------------------------------------------
      *> PRIVATE. Return the outputs Dictionary
      *>------------------------------------------------------------
       Method-id. "getOutputs".

       local-storage section.
       01  lsPointer                   pointer.

       linkage section.
       01  lnkOutputs                  object reference.
       copy "compnent.cpy".

       procedure division returning lnkOutputs.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           set lnkOutputs to outputs
           exit method.
       end method "getOutputs".
      *>---------------------------------------------------------
      *> Registers a particular CallBack for an event which this
      *> object may receive. The event is identified by an event
      *> index. See the file P2CEVENT.CPY.
      *> Warning, presently there is no error detection on trying
      *> to register callbacks for events that objects can't
      *> possibly receive. For example an exception WOULD NOT be
      *> raised if the user tried to register a callback for
      *> a resize event on a button. The effect would be that the
      *> callback would never get called.
      *>---------------------------------------------------------
       method-id. "setEvent".
       local-storage section.
       01 lsEventHandler               object reference.
       01 lsEventDictionary            object reference.
       01 lsHandlersAssoc              object reference.
       01 lsEventHandlerDict           object reference.
       01 lsTranslateHandlerDict       object reference.
       01 lsNumberHandlers             pic x(4) comp-5.

       linkage section.
       01 lnkEventIndex                pic s9(9) comp-5.
       01 lnkEventHandler              object reference.

       procedure division using lnkEventIndex lnkEventHandler.
           invoke SystemDictionary "atZ" using
                                         "MFCLEventHandlers" & x"00"
                                returning lsEventDictionary
           if lsEventDictionary = null
               move numberOfEventObjects to lsNumberHandlers
               invoke IdentityDictionary "ofValues" using Association
                                                    lsNumberHandlers
                                          returning lsEventDictionary
               invoke SystemDictionary "atZPut" using
                                         "MFCLEventHandlers" & x"00"
                                         lsEventDictionary
           end-if
           invoke lsEventDictionary "atOrNil" using self
                                          returning lsHandlersAssoc
           if lsHandlersAssoc = null
               move numberOfRegisteredEvents to lsNumberHandlers
               invoke IdentityDictionary "ofValues"
                           using cobolcomp5association
                                 lsNumberHandlers
                       returning lsEventHandlerDict
               invoke IdentityDictionary "ofValues"
                           using cobolcomp5association
                                 lsNumberHandlers
                       returning lsTranslateHandlerDict
               invoke Association "keyData" using
                                        lsTranslateHandlerDict
                                        lsEventHandlerDict
                              returning lsHandlersAssoc

               invoke lsEventDictionary "atPut" using self
                                                      lsHandlersAssoc
           end-if
           invoke lnkEventhandler "copy" returning lsEventHandler
           invoke lsEventHandlerDict "atPut" using lnkEventIndex
                                                   lsEventhandler
           exit method.
       end method "setEvent".
      *>---------------------------------------------------------
      *> Registers a particular CallBack for an event which this
      *> object may receive. The event is identified by an event
      *> index. See the file P2CEVENT.CPY.
      *> Warning, presently there is no error detection on trying
      *> to register callbacks for events that objects can't
      *> possibly receive. For example an exception WOULD NOT be
      *> raised if the user tried to register a callback for
      *> a resize event on a button. The effect would be that the
      *> callback would never get called.
      *>---------------------------------------------------------
       method-id. "setEventTo".
       local-storage section.
       01 lsCallback            object reference.

       linkage section.
       01 lseventindex          pic s9(9) comp-5.
       01 lsReceiver            object reference.
       01 lsmethodName          pic x.
       01 lsParameter1          object reference.
       01 lsParameter2          object reference.

       procedure division using lseventindex
                                lsReceiver
                                lsMethodName
                                lsParameter1
                                lsParameter2.
           invoke Callback "new" using lsReceiver
                                       lsMethodName
                                       lsParameter1
                                       lsParameter2
                             returning lsCallback
           invoke self "setEvent" using lsEventIndex lsCallBack
      *----Finalize event object
           invoke lsCallBack "finalize" returning lsCallBack
           exit method.

       end method "setEventTo".

      *>---------------------------------------------------------
      *> Translate the event lnkEventIndex for this object into
      *> the event lnkTranslatedEvent on lsReceiver.
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>---------------------------------------------------------
       method-id. "translateEvent".
       local-storage section.
       01 lsAssoc                      object reference.
       01 lsEventDictionary            object reference.
       01 lsHandlersAssoc              object reference.
       01 lsEventHandlerDict           object reference.
       01 lsTranslateHandlerDict       object reference.
       01 lsNumberHandlers             pic x(4) comp-5.

       linkage section.
       01 lnkEventIndex                pic s9(9) comp-5.
       01 lnkTranslatedEvent           pic s9(9) comp-5.
       01 lnkReceiver                  object reference.

       procedure division using lnkEventIndex lnkReceiver
                                lnkTranslatedEvent.
           if lsEventDictionary = null
               move numberOfEventObjects to lsNumberHandlers
               invoke IdentityDictionary "ofValues" using Association
                                                    lsNumberHandlers
                                          returning lsEventDictionary
               invoke SystemDictionary "atZPut" using
                                         "MFCLEventHandlers" & x"00"
                                         lsEventDictionary
           end-if
           invoke lsEventDictionary "atOrNil" using self
                                          returning lsHandlersAssoc
           if lsHandlersAssoc = null
               move numberOfRegisteredEvents to lsNumberHandlers
               invoke IdentityDictionary "ofValues"
                           using cobolcomp5association
                                 lsNumberHandlers
                       returning lsEventHandlerDict
               invoke IdentityDictionary "ofValues"
                           using cobolcomp5association
                                 lsNumberHandlers
                       returning lsTranslateHandlerDict
               invoke Association "keyData" using
                                        lsTranslateHandlerDict
                                        lsEventHandlerDict
                              returning lsHandlersAssoc

               invoke lsEventDictionary "atPut" using self
                                                      lsHandlersAssoc
           end-if
           invoke cobolcomp5Association "keyData" using
                                        lnkTranslatedEvent lnkReceiver
                              returning lsAssoc
           invoke lsTranslateHandlerDict "atPut" using lnkEventIndex
                                                       lsAssoc
           exit method.
       end method "translateEvent".
      *>---------------------------------------------------------
      *> Invoke the associated event handler for the event
      *> lsEventIndex.
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>---------------------------------------------------------
       method-id. "doEvent".
       local-storage section.
       01 lsEvent                  object reference.

       linkage section.
       01 lnkEventIndex            pic s9(9) comp-5.
       01 lnkResult                object reference.
       procedure division using lnkEventIndex returning lnkResult.
      *----Create an event object and invoke the CallBack.
           invoke Event "new" returning lsEvent
           invoke lsEvent "setObject" using self
           invoke lsEvent "setId" using lnkEventIndex
           invoke self "dispatchEvent" using lsEvent
                                   returning lnkResult
           invoke lsEvent "finalize" returning lsEvent
           exit method.
       end method "doEvent".
      *>---------------------------------------------------------
      *> Dispatch the event lnkEvent to a registered callback if
      *> one exists.
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>---------------------------------------------------------
       method-id. "dispatchEvent".
       local-storage section.
       01 lsEventDictionary        object reference.
       01 lsHandlersAssoc          object reference.
       01 lsEventHandlers          object reference.
       01 lsTranslateHandlers      object reference.
       01 lsEventMethod            object reference.
       01 lsObject                 object reference.
       01 lsTranslateAssoc         object reference.
       01 lsEventIndex             pic x(4) comp-5.

       linkage section.
       01 lnkResult                object reference.
       01 lnkEvent                 object reference.

       procedure division using lnkEvent returning lnkResult.
      *----Get the event handling dictionary from the system dictionary.
           invoke SystemDictionary "atZ" using
                                         "MFCLEventHandlers" & x"00"
                                returning lsEventDictionary
           if lsEventDictionary <> null
               invoke lsEventDictionary "atOrNil" using self
                                              returning lsHandlersAssoc
               if lsHandlersAssoc <> null
                   invoke lnkEvent "getId" returning lsEventIndex
      *------------Get the translate events dictionary
                   invoke lsHandlersAssoc "getKey"
                                      returning lsTranslateHandlers
      *------------Get the method events dictionary
                   invoke lsHandlersAssoc "getData"
                                          returning lsEventHandlers
      *------------Get the CallBack for this event, if there is one
                   invoke lsEventHandlers "atOrNil" using lsEventIndex
                                                returning lsEventMethod
                   if lsEventMethod <> null
                      invoke lsEventMethod "invoke" using lnkEvent
                                                returning lnkResult
                   end-if
      *------------Get the translation for this event, if there is one
                   invoke lstranslatehandlers "atOrNil"
                                               using lsEventIndex
                                           returning lsTranslateAssoc
                   if lsTranslateAssoc <> null
      *----------------Get event index and object to map lnkEvent to
                       invoke lsTranslateAssoc "getKey"
                                             returning lsEventIndex
                       invoke lsTranslateAssoc "getData"
                                             returning lsObject
                       invoke lsObject "doEvent" using lsEventIndex
                                             returning lnkResult
                   end-if
               end-if
           end-if
            exit method.
       end method "dispatchEvent".
      *>---------------------------------------------------------
      *> PRIVATE. Remember lnkObject is dependant on this
      *> object.
      *>---------------------------------------------------------
       method-id. "addSignalDependant".

       Local-Storage Section.
       01  lsPointer               pointer.

       Linkage Section.
       01  lnkObject               object reference.
       copy "compnent.cpy".

       procedure division using lnkObject.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           invoke dependants "add" using lnkObject
       end method "addSignalDependant".
      *>---------------------------------------------------------
      *> PRIVATE. Disconnect this component from any output
      *> signal callbacks.
      *>---------------------------------------------------------
       method-id. "disconnect".

       Local-Storage Section.
       01  lsBool                  usage object reference.
       01  lsCallback              object reference.
       01  lsPointer               pointer.

       Linkage Section.
       copy "compnent.cpy".

       procedure division.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           if dependants <> null
               invoke Callback "new" using self
                                           "disconnectInstance "
                                 returning lsCallback
               invoke dependants "do" using lsCallback
               invoke dependants "finalize" returning dependants
               invoke lsCallback "finalize" returning lsCallback
           end-if
           if outputs <> null
               invoke Callback "new" using self
                                           "removeSignalDependents "
                                 returning lsCallback
               invoke outputs "do" using lsCallback
               invoke lsCallback "finalize" returning lsCallback
           end-if
           invoke ExceptionManager "cancel" using self
                   returning lsBool
           invoke outputs "reallydeepFinalize" returning outputs
           invoke spies "finalize" returning spies
           invoke sockets "reallydeepFinalize" returning sockets
           exit method.
       end method "disconnect".
      *>---------------------------------------------------------
      *> PRIVATE. Invoked as part of the disconnection iteration
      *>---------------------------------------------------------
       method-id. "disconnectInstance".

       Local-Storage Section.

       Linkage Section.
       01  lnkComponent            object reference.

       procedure division using lnkComponent.
           invoke lnkComponent "removeHandler" using self
           exit method.
       end method "disconnectInstance".

      *>---------------------------------------------------------
      *> PRIVATE. Invoked as part of the disconnection iteration
      *>---------------------------------------------------------
       method-id. "removeHandler".

       Local-Storage Section.
       01  lsCallback              object reference.
       01  bool                    pic x comp-5.
           88 isTrue               value 1.
       01  lsPointer               pointer.

       Linkage Section.
       01  lnkComponent            object reference.
       copy "compnent.cpy".

       procedure division using lnkComponent.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           if outputs <> null
               invoke dependants "includes" using lnkComponent
                                        returning bool
               if isTrue
      *------------make sure we don't refer to a finalized object
                   invoke dependants "remove" using lnkComponent
               end-if
               invoke Callback "new" using self
                                           "disconnectSignals "
                                           lnkComponent
                                 returning lsCallback
               invoke outputs "do" using lsCallback
               invoke lsCallback "finalize" returning lsCallback
           end-if
           exit method.
       end method "removeHandler".
      *>---------------------------------------------------------
      *> PRIVATE. Invoked as part of the disconnection iteration
      *>---------------------------------------------------------
       method-id. "disconnectSignals".

       Local-Storage Section.
       01  lsCallback              object reference.

       Linkage Section.
       01  lnkSignalHandlers       object reference.
       01  lnkComponent            object reference.

       procedure division using lnkComponent lnkSignalHandlers.
           invoke Callback "new" using self
                                       "disconnectCallback "
                                       lnkSignalHandlers
                                       lnkComponent
                             returning lsCallback
           invoke lnkSignalHandlers "do" using lsCallback
           invoke lsCallback "finalize" returning lsCallback
           exit method.
       end method "disconnectSignals".

      *>---------------------------------------------------------
      *> PRIVATE. Invoked as part of the disconnection iteration
      *>---------------------------------------------------------
       method-id. "disconnectCallback".

       Local-Storage Section.
       01  lsReceiver              object reference.

       Linkage Section.
       01  lnkSignalHandlers       object reference.
       01  lnkCallback             object reference.
       01  lnkComponent            object reference.

       procedure division using lnkSignalHandlers
                                lnkComponent
                                lnkCallback.
           invoke lnkCallback "getReceiver" returning lsReceiver
           if lsReceiver = lnkComponent
               invoke lnkSignalHandlers "remove" using lnkCallback
               invoke lnkCallback "finalize" returning lnkCallback
           end-if
           exit method.
       end method "disconnectCallback".

      *>----------------------------------------------------------------
      *> PRIVATE. Return the address of an object's instance data.
      *>----------------------------------------------------------------
       method-id. "getInstanceData".
       local-storage section.
       01 lsDataSize             pic s9(9) comp-5.
       01 lsStatusCode           pic s9(9) comp-5.
       01 lsDynamicDataOffset    pic s9(9) comp-5.
       01 i                      pic s9(9) comp-5.

       linkage section.
       01 lnkDataPointer         pointer.

       procedure division returning lnkDataPointer.
           call "oopsgetaddress" using self
                                       lnkDataPointer
                                       lsDataSize
                             returning lsStatusCode
           call "oopsindexeddataoffset" using selfClass
                                    returning lsDynamicDataOffset
           set lnkdataPointer up by lsDynamicDataOffset
           exit method.
       end method "getInstanceData".
      *>------------------------------------------------------------
      *> Cause exception to be generated on duplicate signal
      *> definition
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       method-id. "duplicatesNotOK".
       local-storage section.
       01  lsPointer               pointer.

       linkage section.
       copy "compnent.cpy".

       procedure division.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to lsPointer
           set duplicatesOK to false
           exit method.
       end method "duplicatesNotOK".

      *>------------------------------------------------------------
      *> Duplicate signal definition is ignored
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>------------------------------------------------------------
       method-id. "duplicatesOK".

       local-storage section.
       01  lsPointer               pointer.

       linkage section.
       copy "compnent.cpy".

       procedure division.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           set duplicatesOK to true
           exit method.
       end method "duplicatesOK".

      *>------------------------------------------------------------
      *> PRIVATE. Write a trace record
      *>------------------------------------------------------------
       Method-id. "writeTrace".

       local-storage section.
       01  lsTraceRecord       object reference.
       01  lsParameter         object reference.
       01  lsTraceData         pic x(256).
       01  lsSize              pic s9(9) comp-5.

       linkage section.
       01  lnkParameter1       pic x.
       01  lnkParameter2       pic x.
       01  lnkParameter3       pic x.
       01  lnkParameter4       pic x.
       01  lnkParameter5       pic x.
       01  lnkParameter6       pic x.
       01  lnkParameter7       pic x.
       01  lnkParameter8       pic x.
       01  lnkParameter9       pic x.

       procedure division using lnkParameter1
                                lnkParameter2
                                lnkParameter3
                                lnkParameter4
                                lnkParameter5
                                lnkParameter6
                                lnkParameter7
                                lnkParameter8
                                lnkParameter9
                                .
               if address of lnkParameter1 not = null
                   invoke CharacterArray "withSpaceOrNullTerminator"
                       using lnkParameter1
                       returning lsTraceRecord
               end-if
               if address of lnkParameter2 not = null
                   invoke CharacterArray "withSpaceOrNullTerminator"
                       using lnkParameter2 returning lsParameter
                   invoke self "concatTrace" using lsTraceRecord
                                                   lsParameter
               end-if
               if address of lnkParameter3 not = null
                   invoke CharacterArray "withSpaceOrNullTerminator"
                       using lnkParameter3 returning lsParameter
                   invoke self "concatTrace" using lsTraceRecord
                                                   lsParameter
               end-if
               if address of lnkParameter4 not = null
                   invoke CharacterArray "withSpaceOrNullTerminator"
                       using lnkParameter4 returning lsParameter
                   invoke self "concatTrace" using lsTraceRecord
                                                   lsParameter
               end-if
               if address of lnkParameter5 not = null
                   invoke CharacterArray "withSpaceOrNullTerminator"
                       using lnkParameter5 returning lsParameter
                   invoke self "concatTrace" using lsTraceRecord
                                                   lsParameter
               end-if
               if address of lnkParameter6 not = null
                   invoke CharacterArray "withSpaceOrNullTerminator"
                       using lnkParameter6 returning lsParameter
                   invoke self "concatTrace" using lsTraceRecord
                                                   lsParameter
               end-if
               if address of lnkParameter7 not = null
                   invoke CharacterArray "withSpaceOrNullTerminator"
                       using lnkParameter7 returning lsParameter
                   invoke self "concatTrace" using lsTraceRecord
                                                   lsParameter
               end-if
               if address of lnkParameter8 not = null
                   invoke CharacterArray "withSpaceOrNullTerminator"
                       using lnkParameter8 returning lsParameter
                   invoke self "concatTrace" using lsTraceRecord
                                                   lsParameter
               end-if
               invoke lsTraceRecord "size" returning lsSize
               if lsSize > 255
                   raise exception traceRecordTooLong
               else
                   invoke lsTraceRecord "asParameter"
                       returning lsTraceData
                   invoke self "trace" using lsTraceData
           exit method.
       end method "writeTrace".


      *>----------------------------------------------------------------
      *> Turns this object into a component.
      *> For more information on Components and Signals see the
      *> file compnent.txt
      *>
      *> This method is only available on 32-bit Object COBOL Systems.
      *>----------------------------------------------------------------
       method-id. "makeComponent".
       local-storage section.
       01  lsDataPointer         usage pointer.
       01  lsInstanceDataSize    pic x(4) comp-5.
       01  lsDynamicDataOffset   pic x(4) comp-5.
       01  lsbool                pic x comp-5.
           88  istrue            value 1.
           88  isfalse           value 0.
       01  i                     pic s9(9) comp-5.
       copy "compnent.cpy".

       procedure division.
           invoke self "isComponent" returning lsbool
           if isFalse
               move length of componentInstanceData to i
               call "oopsgetaddress" using self
                                       lsDataPointer
                                       lsInstanceDataSize
               call "oopsindexeddataoffset" using selfClass
                               returning lsDynamicDataOffset
               add lsInstanceDataSize to i
               subtract lsDynamicDataOffset from i
               invoke self "basicGrow" using i
                                   returning lsbool
               if isfalse
                   move 32 to i
                   invoke self "raiseException" using i
               else
                   invoke self "becomeComponent" using i
               end-if
           end-if
           exit method.
       end method "makeComponent".
      *>----------------------------------------------------------------
      *> PRIVATE. Determine if this instance is a component
      *>----------------------------------------------------------------
       method-id. "isComponent".
       local-storage section.
       01 lsFlag               pic x(4) comp-5.
       linkage section.
       01  lnkbool             pic x comp-5.
           88  istrue          value 1.
           88  isfalse         value 0.

       procedure division returning lnkbool.
           call "oopsgetpropertyflag" using by value self
                       by reference lsFlag
           if lsFlag > 0
               set isTrue to true
           else
               set isFalse to true
           end-if
           exit method.
       end method "isComponent".
      *>----------------------------------------------------------------
      *> PRIVATE. Returns true if object is indexed. Is overridden by
      *> indexed collection classes.
      *>----------------------------------------------------------------
       method-id. "isIndexed".
       local-storage section.

       linkage section.
       01 lnkBool              pic x comp-5.
           88  isTrue          value 1.
           88  isFalse         value 0.

       procedure division returning lnkbool.
           set isFalse to true
           exit method.
       end method "isIndexed".


      *>----------------------------------------------------------------
      *> PRIVATE. Returns true if object is a gadget.
      *>----------------------------------------------------------------
       method-id. "isGadget".
       local-storage section.

       linkage section.
       01 lnkBool              pic x comp-5.
           88  isTrue          value 1.
           88  isFalse         value 0.

       procedure division returning lnkbool.
           set isFalse to true
           exit method.
       end method "isGadget".
      *>----------------------------------------------------------------
      *> PRIVATE. Causes the indexed portion of this object to grow
      *> to a size of lnkSize bytes. The primitive "OOPSGROW" must never
      *> be called directly therefore all grow operations must be
      *> performed through use of this or a similar method.
      *>----------------------------------------------------------------
       method-id. "basicGrow".
       linkage section.
       01 lnksize                 pic s9(9) comp-5.
       01 lnkbool                 pic x comp-5.
           88  lnkistrue          value 1.
           88  lnkisfalse         value 0.

       procedure division using lnksize returning lnkbool.
           if lnksize < zero
               invoke self "invalidParameter" returning lnkbool
           else
               call "oopsgrow" using self lnksize returning lnkbool
           end-if
           exit method.
       end method "basicGrow".

      *>----------------------------------------------------------------
      *> PRIVATE. Write a trace record
      *>----------------------------------------------------------------
       method-id. "trace".

       local-storage section.

       linkage section.
       01 lnkRecord               pic x.

       procedure division using lnkRecord.
           call "oopstrace" using lnkRecord
           exit method.
       end method "trace".
      *>------------------------------------------------------------
      *> PRIVATE. Concatenate characterarray, finalize both and
      *> return new characterarray
      *>------------------------------------------------------------
       Method-id. "concatTrace".
       local-storage section.
       01  temp                object reference.

       linkage section.
       01  firstString         object reference.
       01  secondString        object reference.

       procedure division using firstString, secondString.
           invoke firstString "concat" using secondString
                               returning temp
           invoke firstString "finalize" returning firstString
           invoke secondString "finalize" returning secondString
           set firstString to temp
           exit method.
       end method "concatTrace".
      *>------------------------------------------------------------
      *> PRIVATE. Component exception handler
      *>------------------------------------------------------------
       Method-id. "componentException".

       local-storage section.
       01  lsChar                          pic x.
       01  lsClassName                     object reference.
       01  lsClassNameText                 pic x(64).
       01  lsPointer                       pointer.
       01  lsmsgfh                         object reference.
       01  tracetext                       pic x(256).
       01  i                               pic x(4) comp-5.
       01  j                               pic x(4) comp-5.
       01  astring                         object reference.
       01  string1                         object reference.
       01  string2                         object reference.
       01  string3                         object reference.

       linkage section.
       01  lnkErrorObject                  object reference.
       01  lnkErrorNumber                  pic x(4) comp-5.
       01  lnkNullReference                object reference.
       01  lnkTextCollection               object reference.
       copy "compnent.cpy".

       procedure division using lnkErrorObject
                                lnkErrorNumber
                                lnkTextCollection
                      returning lnkNullReference.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           set lnkNullReference to null
           move low-values to lsClassNameText
           invoke self "registerBaseMessageFile"
                                returning lsmsgfh
           invoke self "description" returning string1
           set string3 to null
           if lnkTextCollection = null then
               set string2 to null
           else
               invoke lnkTextCollection "size" returning j
               if j >= 1 then
                   move 1 to i
                   invoke lnkTextCollection "at" returning string2
                   if j >= 2 then
                       move 2 to i
                       invoke lnkTextCollection "at" returning string3
                   end-if
               end-if
           end-if
           evaluate lnkErrorNumber
               when inputSocketUndefined
           *>> LNG 21: ">> Component: %s undefined input socket: %s"
                   move 2 to i
                   move 21 to j
                   invoke lsmsgfh "getmessage"
                       using i j string1 string2
                       returning astring
                   invoke aString "display"

                   if signalTracing
                       perform write-trace
                   end-if
                   invoke astring "finalize" returning astring
               when outputSocketUninitialized
           *>> LNG 22: ">> Component: %s output socket uninitialized"
                   move 2 to i
                   move 22 to j
                   invoke lsmsgfh "getmessage"
                       using i j string1
                       returning astring
                   invoke aString "display"

                   if signalTracing
                       perform write-trace
                   end-if
                   invoke astring "finalize" returning astring
               when outputSignalUndefined
           *>> LNG 23:">> Component: %1$s output signal undefined: %2$s"
                   move 2 to i
                   move 23 to j
                   invoke lsmsgfh "getmessage"
                       using i j string1 string2
                       returning astring
                   invoke aString "display"

                   if signalTracing
                       perform write-trace
                   end-if
                   invoke astring "finalize" returning astring

               when duplicateOutputSignal
           *>> LNG 24:">> Component: %1$s duplicate output signal: %2$s"
                   move 2 to i
                   move 24 to j
                   invoke lsmsgfh "getmessage"
                       using i j string1 string2
                       returning astring
                   invoke aString "display"

                   if signalTracing
                       perform write-trace
                   end-if
                   invoke astring "finalize" returning astring

               when duplicateInputSignal
           *>> LNG 25: ">> Component: %1$s duplicate input signal: %2$s on socket: %3$s"
                   move 2 to i
                   move 25 to j
                       invoke lsmsgfh "getmessage"
                       using i j string1 string2 string3
                       returning astring
                   invoke aString "display"

                   if signalTracing
                       perform write-trace
                   end-if
                   invoke astring "finalize" returning astring

               when internalError
           *>> LNG 26: ">> Component: %1$s internal error: %2$s"
                   move 2 to i
                   move 26 to j
                   invoke lsmsgfh "getmessage"
                       using i j string1 string2
                       returning astring
                   invoke aString "display"

                   if signalTracing
                       perform write-trace
                   end-if
                   invoke astring "finalize" returning astring

               when other
      *------------This is an exception this handler cannot handle.
      *            The exception is reraised and unless trapped
      *            elsewhere terminates the application.
                   invoke self "raiseExceptionwithtextcollection" 
                          using lnkErrorNumber
                                lnkTextCollection
               end-evaluate
               invoke string1 "finalize" returning string1
               invoke lsmsgfh "finalize" returning lsmsgfh
           exit method.

           write-trace section.
               invoke astring "size" returning i
               if i < 256 then
                   invoke aString "getvalue" using tracetext
                   move x'00' to tracetext(i + 1:1)
                   writetrace with tracetext
               end-if
               .
       end method "componentException".
      *>------------------------------------------------------------
      *> PRIVATE. Determine if signal tracing and set instance flag
      *>------------------------------------------------------------
       Method-id. "isSignalTracing".

       working-storage section.
       01  signalTracing       pic s9(9) comp-5 value 65536.

       local-storage section.
       01  traceLevel          pic s9(9) comp-5.

       linkage section.
       01  lnkBool             pic x comp-5.
           88 isTrue           value 1.
           88 isFalse          value 0.

       procedure division returning lnkBool.
           call "oopsgettracelevel" returning traceLevel
           call "CBL_AND" using signalTracing, tracelevel
                                by value 4
           if traceLevel = signalTracing
               set isTrue to true
           else
               set isFalse to true
           end-if
           exit method.
       end method "isSignalTracing".
      *>----------------------------------------------------------------
      *> PRIVATE. Set up the comms area to contain the debug
      *> description which will be displayed in the object inspector
      *> when inspecting this object.
      *>----------------------------------------------------------------
       method-id. "debugDescription".
       working-storage section.
       01 ws-dummy         pic x.
       01 func-code        pic x comp-x value 24.
       01 ws-string.
           03 ws-str-len   pic x comp-x.
           03 ws-real-len  pic x comp-x.
           03 ws-vrn       pic x comp-x.
           03 ws-flags     pic x comp-x.
           03 ws-str       pic x(76).
       local-storage section.
       01 lsStringLen      pic x(4) comp-5.
       01 lsString         usage object reference.
       01 lsPtr            usage pointer.
       linkage section.
       01 lnkRealString    pic x.
       procedure division.
           invoke self "description" returning lsString
           invoke lsString "sizeInBytes" returning lsStringLen
           invoke self "malloc" using lsStringLen returning lsPtr
           set address of lnkRealString to lsPtr
           invoke lsString "getValue" returning lnkRealString
           move 80 to ws-str-len
           if lsStringLen > 76
               move 76 to ws-real-len
           else
               move lsStringLen to ws-real-Len
           end-if
           move lnkRealString(1:ws-real-len) to ws-str
           move zero to ws-vrn
           move zero to ws-flags
           call x"91" using ws-dummy func-code ws-string
           invoke self "dealloc" using lsPtr
           exit method.
       end method "debugDescription".
      *>----------------------------------------------------------------
      *> Raise an exception indicating two collections are incompatible.
      *>----------------------------------------------------------------
       method-id. "CompatibilityError".
       local-storage section.
       01 exceptionNumber  pic x(4) comp-5.
       linkage section.
       01 lnkResult        usage object reference.
       procedure division returning lnkResult.
           move 10 to exceptionnumber
           invoke self "raiseException" using exceptionnumber
                                             returning lnkResult.
           exit method.
       end method "CompatibilityError".

      *>----------------------------------------------------------------
      *> Return true if this type of collection contains characters
      *>----------------------------------------------------------------
       method-id. "containsCharacters".
       linkage section.
       01 lnkbool                  pic x comp-5.
           88  lnkistrue           value 1.
           88  lnkisfalse          value 0.
       01 acollection              usage object reference.

       procedure division returning lnkbool.
           set lnkIsFalse to true
           exit method.
       end method "ContainsCharacters".
      *>----------------------------------------------------------------
      *> Return true if this type of collection contains
      *> DBCS characters
      *>----------------------------------------------------------------
       method-id. "containsDBCSCharacters".
       linkage section.
       01 lnkbool                  pic x comp-5.
           88  lnkistrue           value 1.
           88  lnkisfalse          value 0.
       01 acollection              usage object reference.

       procedure division returning lnkbool.
           set lnkIsFalse to true
           exit method.
       end method "ContainsDBCSCharacters".
      *>----------------------------------------------------------------
      *> Return true if this instance is an instance of the class
      *> lnkClass or if its class inherits either directly or indirectly
      *> from lnkClass.
      *>----------------------------------------------------------------
       method-id. "isTypeOf".
       local-storage section.
       01 lsClass                usage object reference.
       linkage section.
       01 lnkbool                pic x comp-5.
       01 lnkClass               usage object reference.

       procedure division using lnkClass returning lnkbool.
           set lsclass to selfclass
           perform until lsclass = lnkClass or lsclass = base
                invoke lsclass "superClass" returning lsclass
           end-perform
           if lsclass = lnkClass
                move 1 to lnkBool
           else
                move 0 to lnkBool
           end-if
           exit method.
       end method "isTypeOf".
      *>---------------------------------------------------------
      *> PRIVATE. Iterator used to remove a signal dependant
      *>---------------------------------------------------------
       method-id. "removeSignalDependents".

       Local-Storage Section.
       01  lsCallback              object reference.

       Linkage Section.
       01  lnkSignalHandlers       object reference.

       procedure division using lnkSignalHandlers.
           invoke Callback "new" using self
                                       "doRemoveSignalDependant "
                             returning lsCallback
           invoke lnkSignalHandlers "do" using lsCallback
           invoke lsCallback "finalize" returning lsCallback
       end method "removeSignalDependents".

      *>---------------------------------------------------------
      *> PRIVATE. iterator to remove a signal dependant
      *>---------------------------------------------------------
       method-id. "doRemoveSignalDependant".

       Local-Storage Section.
       01  lsReceiver              object reference.

       Linkage Section.
       01  lnkCallback             object reference.

       procedure division using lnkCallback.
           invoke lnkCallback "getReceiver" returning lsReceiver
           invoke lsReceiver "removeSignalDependant" using self
       end method "doRemoveSignalDependant".

      *>---------------------------------------------------------
      *> Removes lnkObject from the signal dependency
      *> list.
      *>---------------------------------------------------------
       method-id. "removeSignalDependant".

       Local-Storage Section.
       01  lsPointer               pointer.
       01  lsBool                  pic x comp-5.
           88 isTrue               value 1.

       Linkage Section.
       01  lnkObject               object reference.
       copy "compnent.cpy".

       procedure division using lnkObject.
           invoke self "getInstanceData" returning lsPointer
           set address of componentInstanceData
           to  lsPointer
           invoke dependants "includes" using     lnkObject
                                        returning lsBool
           if isTrue
               invoke dependants "remove" using lnkObject
           end-if
       end method "removeSignalDependant".

      *>----------------------------------------------------------------
      *> Report an error for this instance using ErrNumber, and up to
      *> six text strings giving additional information about the cause
      *> of the error. This method will create an ordered collection to
      *> hold the text strings, and pass it to a user defined exception
      *> handler if one has been registered.
      *>----------------------------------------------------------------
       method-id. "raiseExceptionWithText".
       local-storage section.
       01 lsResult             usage object reference.
       01 lsordcll             usage object reference.
       01 lssize               pic x(4) comp-5.
       linkage section.
       01 result               usage object reference.
       01 errnumber            pic x(4) comp-5.
       01 lnkstring1           usage object reference.
       01 lnkstring2           usage object reference.
       01 lnkstring3           usage object reference.
       01 lnkstring4           usage object reference.
       01 lnkstring5           usage object reference.
       01 lnkstring6           usage object reference.

       procedure division using errnumber
                                lnkstring1
                                lnkstring2
                                lnkstring3
                                lnkstring4
                                lnkstring5
                                lnkstring6
                      returning result.
           if address of result = null
               set address of result to address of lsResult
           end-if
           if address of lnkstring1 = null then
               set lsordcll to null
           else
               move 6 to lssize
               invoke OrderedCollection "ofReferences"
                                       using lssize
                                   returning lsordcll
               invoke lsordcll "add" using lnkstring1
               if address of lnkstring2 not = null then
                 invoke lsordcll "add" using lnkstring2
                 if address of lnkstring3 not = null then
                   invoke lsordcll "add" using lnkstring3
                   if address of lnkstring4 not = null then
                     invoke lsordcll "add" using lnkstring4
                     if address of lnkstring5 not = null then
                       invoke lsordcll "add" using lnkstring5
                       if address of lnkstring6 not = null then
                         invoke lsordcll "add" using lnkstring6
                       end-if
                     end-if
                   end-if
                 end-if
               end-if
           end-if
           if self equal to null
               invoke ExceptionManager "raisestatic" using
                                            selfclass
                                            errnumber
                                            lsordcll
                                        returning result
           else
               invoke ExceptionManager "raise" using
                                            self
                                            errnumber
                                            lsordcll
                                        returning result
           end-if
           exit method.
       end method "raiseExceptionWithText".
      *>----------------------------------------------------------------
      *> Report an error for this instance using ErrNumber, and up to
      *> six null-terminated text strings giving additional information
      *> about the cause of the error. This method will create an
      *> ordered collection to hold the text strings, and pass it to a
      *> user defined exception handler if one has been registered.
      *>----------------------------------------------------------------
       method-id. "raiseExceptionWithTextZ".
       local-storage section.
       01 lsResult             usage object reference.
       01 lsordcll             usage object reference.
       01 lssize               pic x(4) comp-5.
       01 lsstring             usage object reference.
       linkage section.
       01 result               usage object reference.
       01 errnumber            pic x(4) comp-5.
       01 lnkstring1           usage object reference.
       01 lnkstring2           usage object reference.
       01 lnkstring3           usage object reference.
       01 lnkstring4           usage object reference.
       01 lnkstring5           usage object reference.
       01 lnkstring6           usage object reference.

       procedure division using errnumber
                                lnkstring1
                                lnkstring2
                                lnkstring3
                                lnkstring4
                                lnkstring5
                                lnkstring6
                      returning result.
           if address of result = null
               set address of result to address of lsResult
           end-if
           if address of lnkstring1 = null then
               set lsordcll to null
           else
               move 6 to lssize
               invoke OrderedCollection "ofReferences"
                                       using lssize
                                   returning lsordcll
               invoke CharacterArray "withvalue" using lnkstring1
                        returning lsString
               invoke lsordcll "add" using lsString
               if address of lnkstring2 not = null then
                   invoke CharacterArray "withvalue"
                               using lnkstring2
                               returning lsString
                   invoke lsordcll "add" using lsString
                   if address of lnkstring3 not = null then
                       invoke CharacterArray "withvalue"
                               using lnkstring3
                               returning lsString
                       invoke lsordcll "add" using lsString
                       if address of lnkstring4 not = null then
                           invoke CharacterArray "withvalue"
                               using lnkstring4
                               returning lsString
                           invoke lsordcll "add" using lsString
                           if address of lnkstring5 not = null then
                               invoke CharacterArray "withvalue"
                                   using lnkstring5
                                   returning lsString
                               invoke lsordcll "add" using lsString
                               if address of lnkstring6 not = null then
                                   invoke CharacterArray "withvalue"
                                       using lnkstring6
                                       returning lsString
                                   invoke lsordcll "add" using lsString
                               end-if
                           end-if
                       end-if
                   end-if
               end-if
           end-if
           if self equal to null
               invoke ExceptionManager "raisestatic" using
                                            selfclass
                                            errnumber
                                            lsordcll
                                        returning result
           else
               invoke ExceptionManager "raise" using
                                            self
                                            errnumber
                                            lsordcll
                                        returning result
           end-if
           exit method.
       end method "raiseExceptionWithTextZ".
      *>----------------------------------------------------------------
      *> PRIVATE. Return the object refernce of the invoker of the
      *> current object.
      *> If invoked from a program, not a class, then lnksender will
      *> contain null.
      *>----------------------------------------------------------------
       method-id. "sender".
       local-storage section.
       01 lsdepth          pic x(4) comp-5.
       linkage section.
       01 lnksender object reference.
       procedure division returning lnksender.
           move 2 to lsdepth
           call "oopsgetsender" using by value lsdepth
                                      returning lnksender
           exit method.
       end method "sender".

      *>----------------------------------------------------------------
      *> Report an error for this instance using ErrNumber, and a 
      *> collection of text strings giving additional information about 
      *> the cause of the error. 
      *> This method would typically be invoked from a user defined 
      *> exception handler which has received an exception it does not 
      *> want to handle itself, in order to pass the exception to another 
      *> exception handler.
      *>----------------------------------------------------------------
       method-id. "raiseExceptionWithTextCollection".
       local-storage section.
       01 lsResult             usage object reference.
       linkage section.
       01 result               usage object reference.
       01 errnumber            pic x(4) comp-5.
       01 lnktextcollection    usage object reference.

       procedure division using errnumber
                                lnktextcollection
                      returning result.
           if address of result = null
               set address of result to address of lsResult
           end-if
           if self equal to null
               invoke ExceptionManager "raisestatic" using
                                            selfclass
                                            errnumber
                                            lnktextcollection
                                        returning result
           else
               invoke ExceptionManager "raise" using
                                            self
                                            errnumber
                                            lnktextcollection
                                        returning result
           end-if
           exit method.
       end method "raiseExceptionWithTextCollection".

       end object.
       end class base.
