      *>---------------------------------------------------------
      *> An instance of an Event is passed as a parameter when an
      *> application receives notification of an event taking
      *> place. Currently this only contains the object that
      *> received the event.
      *>
      *> Copyright (C) 1991,1996 Micro Focus Ltd
      *>
      *>---------------------------------------------------------
      $set mfoo

       class-id. event data is protected
               inherits from base with data.

        object section.
        class-control.
           event is class "event"
           base is class "base".
       working-storage section.
       01 OO-Desktop      usage object reference external.
       object-storage section.

       Object.

       object-storage section.
       01 receiver usage object reference value null.
       01 eventId  pic x(4) comp-5 value 0.
      *>---------------------------------------------------------
      *> PRIVATE. Sets the receiver of the event
      *>---------------------------------------------------------
       method-id. "setObject".
       linkage section.
       01 lnkObject usage object reference.

       procedure division using lnkObject.
           set receiver to lnkObject
           exit method.
       end method "setObject".

      *>---------------------------------------------------------
      *> Set the id of the event
      *>---------------------------------------------------------
       method-id. "setId".
       linkage section.
       01 lnkEventId pic x(4) comp-5.

       procedure division using lnkEventId.
           move lnkEventId to eventId
           exit method.
       end method "setId".
      *>---------------------------------------------------------
      *> Return the id of the event
      *>---------------------------------------------------------
       method-id. "getId".
       linkage section.
       01 lnkEventId pic x(4) comp-5.

       procedure division returning lnkEventId.
           move eventId to lnkEventId
           exit method.
       end method "getId".
      *>---------------------------------------------------------
      *> Return the object that received the event.
      *>---------------------------------------------------------
       method-id. "getObject".
       linkage section.
       01 lnkObject usage object reference.

       procedure division returning lnkObject.
           set lnkObject to receiver
           exit method.
       end method "getObject".
      *>---------------------------------------------------------
      *> Return the X location of the mouse for the last event
      *>---------------------------------------------------------
       method-id. "getX".
       local-storage section.
       01 eventManager usage object reference.

       linkage section.
       01 lnkX pic x(4) comp-5.
       procedure division returning lnkX.
           invoke OO-Desktop "eventManager" returning eventManager
           invoke eventManager "getX" returning lnkX
           exit method.
       end method "getX".
      *>---------------------------------------------------------
      *> Return the Y location of the mouse for the last event
      *>---------------------------------------------------------
       method-id. "getY".
       local-storage section.
       01 eventManager usage object reference.
       linkage section.
       01 lnkY pic x(4) comp-5.
       procedure division returning lnkY.
           invoke OO-Desktop "eventManager" returning eventManager
           invoke eventManager "getY" returning lnkY
           exit method.
       end method "getY".
      *>----------------------------------------------------------
      *> Return the two bytes of keyboard data for the
      *> last event. If the last event was not a keyboard event
      *> then rubbish will be returned. To interpret these two
      *> bytes of data refer to the online help for panels2.
      *>----------------------------------------------------------
       method-id. "getKeyBoardData".
       local-storage section.
       01 eventManager usage object reference.
       linkage section.
       01 lnkkeyboarddata.
            03 lnkbyte-1      pic 9(2) comp-5.
            03 lnkbyte-2      pic 9(2) comp-5.

       procedure division returning lnkkeyboarddata.
           invoke OO-Desktop "eventManager" returning eventManager
           invoke eventManager "getKeyBoardData"
                                            returning lnkkeyboarddata
           exit method.
       end method "getKeyBoardData".
      *>---------------------------------------------------------
      *> Return a boolean indicating whether the mouse has moved.
      *>---------------------------------------------------------
       method-id. "mouseMoved".
       local-storage section.
       01 eventManager usage object reference.
       linkage section.
       01 lnkBool  pic x comp-5.
       procedure division returning lnkBool.
           invoke OO-Desktop "eventManager" returning eventManager
           invoke eventManager "mouseMoved" returning lnkBool
           exit method.
       end method "mouseMoved".
       end object.
       end class event.
