      *>----------------------------------------------------------------
      *> RecursiveSet is a private class which is used by the class
      *> library to prevent recursive display of collections.
      *>
      *> Copyright (C) 1991,1996 Micro Focus Ltd
      *>
      *>----------------------------------------------------------------
      $set mfoo

       class-id. RecursiveSet is abstract data is protected
               inherits from base with data.


        object section.
        class-control.
           base is class "base"
           identitySet is class "iset"
           RecursiveSet is class "recurset".
       object-storage section.
       01 aSet usage object reference value null.
      *>---------------------------------------------------------------
      *> Adds an object to the recursive set.
      *>---------------------------------------------------------------
       method-id. "add".
       local-storage section.
       01 localSet usage object reference.
       linkage section.
       01 lnkObject    usage object reference.
       procedure division using lnkObject.
           invoke self "getSet" returning localSet
           invoke localSet "add" using lnkObject
       end method "add".
      *>---------------------------------------------------------------
      *> Removes an object from the recursive set.
      *>---------------------------------------------------------------

       method-id. "remove".
       local-storage section.
       01 localSet usage object reference.
       linkage section.
       01 lnkObject    usage object reference.
       procedure division using lnkObject.
           invoke self "getSet" returning localSet
           invoke localSet "remove" using lnkObject
       end method "remove".
      *>---------------------------------------------------------------
      *> Returns the actual set used for the implementation of this
      *> class.
      *>---------------------------------------------------------------

       method-id. "getSet".
       local-storage section.
       01 localSet usage object reference.
       01 i        pic x(4) comp-5.
       linkage section.
       01 result    usage object reference.
       procedure division returning result.
           if aSet = null
               move 50 to i
               invoke IdentitySet "ofReferences" using i
                       returning aSet
           end-if
           set result to aSet
       end method "getSet".
      *>---------------------------------------------------------------
      *> Returns true if this set includes lnkObject.
      *>---------------------------------------------------------------
       method-id. "includes".
       local-storage section.
       01 localSet usage object reference.
       linkage section.
       01 lnkObject    usage object reference.
       01 lnkBool      pic x comp-5.
       procedure division using lnkObject returning lnkBool.
           invoke self "getSet" returning localSet
           invoke localSet "includes" using lnkObject returning lnkBool
       end method "includes".
       Object.
       object-storage section.
       end object.
       end class RecursiveSet.
